/********************************************************************
 *
 * PROGRAM:  CrazyPads
 * PART:     gadtools.c
 * CONTENTS: data for the userinterface
 *
 * (c) Copyright 1990-94 by Klaus Rotter. All rights reserved
 * EMail: klaus@rotters.de
 *
 * Use it at your own risk. The program and the source code may be 
 * distributed under the terms of the GNU Public Licence (GPL).
 * For more Informations read mainmodule (MAIN.C)
 * Please read CrazyPads.doc before using it.
 *
 ********************************************************************/

/********************************************************************
 *
 * How to put GadToolsBox generated C-Src-Codes into CrazyPads:
 *
 * 1) Remove everything below "**** GadToolsBox Source *****"
 * 2) Load new GadToolsBox Source
 * 3) Remove all #includes
 * 4) Remove the complete code of the functions
 *	       CreateMenus()
 *	       LayoutMenus()
 *	       SetMenuStrip()
 *
 *    They can be found in OpenPrintXWindow()
 *
 * 5) Remove "static" before ComputeX() and ComputeY()
 * 6) Delete the file gadtools.h and replace it with the .h file
 *    generated by GTB
 * 7) Now compile it... and have fun !
 *
 ********************************************************************/

#include "defs.h"
#include "/obj/prog-protos.h"

Prototype UWORD ComputeX(UWORD);
Prototype UWORD ComputeY(UWORD);

#define NULL (0)

/************************* GadToolsBox Source ***********************/

/*
 *  Source machine generated by GadToolsBox V2.0b
 *  which is (c) Copyright 1991-1993 Jaba Development
 *
 *  GUI Designed by : Klaus Rotter
 */

struct Screen	      *Scr = NULL;
UBYTE		      *PubScreenName = NULL;
APTR		       VisualInfo = NULL;
struct Window	      *PlotWnd = NULL;
struct Window	      *PrintXWnd = NULL;
struct Window	      *GetPartWnd = NULL;
struct Window	      *BoardPrefWnd = NULL;
struct Window	      *MiscWnd = NULL;
struct Window	      *EditPadsWnd = NULL;
struct Window	      *Step_mmWnd = NULL;
struct Window	      *Grid_mmWnd = NULL;
struct Window	      *PrintingWnd = NULL;
struct Window	      *PartsLibWnd = NULL;
struct Window	      *BuildPageWnd = NULL;
struct Window	      *SpecialWnd = NULL;
struct Window	      *AboutWnd = NULL;
struct Window	      *TraceLabelWnd = NULL;
struct Window	      *PaletteWnd = NULL;
struct Window	      *EditNameWnd = NULL;
struct Window	      *EditSinglePadWnd = NULL;
struct Gadget	      *PlotGList = NULL;
struct Gadget	      *PrintXGList = NULL;
struct Gadget	      *GetPartGList = NULL;
struct Gadget	      *BoardPrefGList = NULL;
struct Gadget	      *MiscGList = NULL;
struct Gadget	      *EditPadsGList = NULL;
struct Gadget	      *Step_mmGList = NULL;
struct Gadget	      *Grid_mmGList = NULL;
struct Gadget	      *PrintingGList = NULL;
struct Gadget	      *PartsLibGList = NULL;
struct Gadget	      *BuildPageGList = NULL;
struct Gadget	      *SpecialGList = NULL;
struct Gadget	      *AboutGList = NULL;
struct Gadget	      *TraceLabelGList = NULL;
struct Gadget	      *PaletteGList = NULL;
struct Gadget	      *EditNameGList = NULL;
struct Gadget	      *EditSinglePadGList = NULL;
struct Menu	      *PlotMenus = NULL;
struct Gadget	      *PlotGadgets[13];
struct Gadget	      *PrintXGadgets[21];
struct Gadget	      *GetPartGadgets[9];
struct Gadget	      *BoardPrefGadgets[13];
struct Gadget	      *MiscGadgets[14];
struct Gadget	      *EditPadsGadgets[63];
struct Gadget	      *Step_mmGadgets[4];
struct Gadget	      *Grid_mmGadgets[5];
struct Gadget	      *PrintingGadgets[1];
struct Gadget	      *PartsLibGadgets[13];
struct Gadget	      *BuildPageGadgets[1];
struct Gadget	      *SpecialGadgets[6];
struct Gadget	      *AboutGadgets[4];
struct Gadget	      *TraceLabelGadgets[22];
struct Gadget	      *PaletteGadgets[6];
struct Gadget	      *EditNameGadgets[8];
struct Gadget	      *EditSinglePadGadgets[13];
UWORD		       PlotLeft = 157;
UWORD		       PlotTop = 25;
UWORD		       PlotWidth = 303;
UWORD		       PlotHeight = 123;
UWORD		       PrintXLeft = 182;
UWORD		       PrintXTop = 13;
UWORD		       PrintXWidth = 302;
UWORD		       PrintXHeight = 171;
UWORD		       GetPartLeft = 213;
UWORD		       GetPartTop = 8;
UWORD		       GetPartWidth = 239;
UWORD		       GetPartHeight = 125;
UWORD		       BoardPrefLeft = 167;
UWORD		       BoardPrefTop = 18;
UWORD		       BoardPrefWidth = 334;
UWORD		       BoardPrefHeight = 165;
UWORD		       MiscLeft = 222;
UWORD		       MiscTop = 6;
UWORD		       MiscWidth = 263;
UWORD		       MiscHeight = 179;
UWORD		       EditPadsLeft = 135;
UWORD		       EditPadsTop = 1;
UWORD		       EditPadsWidth = 410;
UWORD		       EditPadsHeight = 184;
UWORD		       Step_mmLeft = 222;
UWORD		       Step_mmTop = 51;
UWORD		       Step_mmWidth = 228;
UWORD		       Step_mmHeight = 61;
UWORD		       Grid_mmLeft = 252;
UWORD		       Grid_mmTop = 47;
UWORD		       Grid_mmWidth = 220;
UWORD		       Grid_mmHeight = 75;
UWORD		       PrintingLeft = 291;
UWORD		       PrintingTop = 81;
UWORD		       PrintingWidth = 142;
UWORD		       PrintingHeight = 54;
UWORD		       PartsLibLeft = 164;
UWORD		       PartsLibTop = 2;
UWORD		       PartsLibWidth = 349;
UWORD		       PartsLibHeight = 183;
UWORD		       BuildPageLeft = 254;
UWORD		       BuildPageTop = 89;
UWORD		       BuildPageWidth = 147;
UWORD		       BuildPageHeight = 36;
UWORD		       SpecialLeft = 227;
UWORD		       SpecialTop = 53;
UWORD		       SpecialWidth = 255;
UWORD		       SpecialHeight = 100;
UWORD		       AboutLeft = 123;
UWORD		       AboutTop = 11;
UWORD		       AboutWidth = 448;
UWORD		       AboutHeight = 170;
UWORD		       TraceLabelLeft = 194;
UWORD		       TraceLabelTop = 18;
UWORD		       TraceLabelWidth = 287;
UWORD		       TraceLabelHeight = 162;
UWORD		       PaletteLeft = 170;
UWORD		       PaletteTop = 62;
UWORD		       PaletteWidth = 380;
UWORD		       PaletteHeight = 94;
UWORD		       EditNameLeft = 169;
UWORD		       EditNameTop = 61;
UWORD		       EditNameWidth = 355;
UWORD		       EditNameHeight = 64;
UWORD		       EditSinglePadLeft = 154;
UWORD		       EditSinglePadTop = 50;
UWORD		       EditSinglePadWidth = 376;
UWORD		       EditSinglePadHeight = 111;
UBYTE		      *PlotWdt = (UBYTE *)" HP-GL Plot";
UBYTE		      *PrintXWdt = (UBYTE *)" Print PCB";
UBYTE		      *GetPartWdt = (UBYTE *)" Get Part";
UBYTE		      *BoardPrefWdt = (UBYTE *)" Board Preferences";
UBYTE		      *MiscWdt = (UBYTE *)" Misc";
UBYTE		      *EditPadsWdt = (UBYTE *)" Edit Pads";
UBYTE		      *Step_mmWdt = (UBYTE *)"Choose new Stepsize";
UBYTE		      *Grid_mmWdt = (UBYTE *)"Choose new Gridsize";
UBYTE		      *PrintingWdt = (UBYTE *)" Printing";
UBYTE		      *PartsLibWdt = (UBYTE *)" Parts Library";
UBYTE		      *BuildPageWdt = (UBYTE *)"Build Page";
UBYTE		      *SpecialWdt = (UBYTE *)" Special";
UBYTE		      *AboutWdt = (UBYTE *)" About CrazyPads...";
UBYTE		      *TraceLabelWdt = (UBYTE *)"Traces & Labels";
UBYTE		      *PaletteWdt = (UBYTE *)" Change Colors";
UBYTE		      *EditNameWdt = (UBYTE *)" Edit Part Name";
UBYTE		      *EditSinglePadWdt = (UBYTE *)" Edit Pad";
struct TextAttr       *Font, Attr;
UWORD		       FontX, FontY;
UWORD		       OffX, OffY;

UBYTE *Pl_ZoomG0Labels[] = {
	(UBYTE *)"Zoom 50%",
	(UBYTE *)"Zoom 75%",
	(UBYTE *)"Zoom 100%",
	(UBYTE *)"Zoom 200%",
	(UBYTE *)"Zoom 300%",
	(UBYTE *)"Zoom 400%",
	(UBYTE *)"Zoom 500%",
	NULL };

UBYTE *Pr_ZoomG1Labels[] = {
	(UBYTE *)"Zoom 50%",
	(UBYTE *)"Zoom 75%",
	(UBYTE *)"Zoom 100%",
	(UBYTE *)"Zoom 200%",
	(UBYTE *)"Zoom 300%",
	(UBYTE *)"Zoom 400%",
	(UBYTE *)"Zoom 500%",
	NULL };

UBYTE *Pr_AspectG1Labels[] = {
	(UBYTE *)"Horizontal",
	(UBYTE *)"Vertical",
	NULL };

UBYTE *BP_OutfitG3Labels[] = {
	(UBYTE *)"None",
	(UBYTE *)"DIN A5",
	(UBYTE *)"DIN A4",
	(UBYTE *)"DIN A3",
	(UBYTE *)"DIN A2",
	NULL };

UBYTE *MC_CoordsG4Labels[] = {
	(UBYTE *)"Millimeter",
	(UBYTE *)"Inch",
	NULL };

UBYTE *MC_DrawLabel4Labels[] = {
	(UBYTE *)"Normal",
	(UBYTE *)"Med",
	(UBYTE *)"Fast",
	NULL };

UBYTE *MC_DrawTracesG4Labels[] = {
	(UBYTE *)"Normal",
	(UBYTE *)"Med",
	(UBYTE *)"Fast",
	NULL };

UBYTE *MC_DrawPadsG4Labels[] = {
	(UBYTE *)"Normal",
	(UBYTE *)"Fast",
	NULL };

UBYTE *EP_Type1G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type2G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type3G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type4G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type5G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type6G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type7G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type8G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type9G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Type0G5Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_Layer1G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer2G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer3G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer4G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer5G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer6G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer7G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer8G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer9G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_Layer0G5Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *CS_StepG6Labels[] = {
	(UBYTE *)"5.08 mm",
	(UBYTE *)"2.54 mm",
	(UBYTE *)"1.27 mm",
	(UBYTE *)"0.635 mm",
	(UBYTE *)"5.0 mm",
	(UBYTE *)"2.0 mm",
	(UBYTE *)"1.0 mm",
	(UBYTE *)"0.8 mm",
	(UBYTE *)"0.65 mm",
	(UBYTE *)"custom",
	NULL };

UBYTE *CG_GridG7Labels[] = {
	(UBYTE *)"5.08 mm",
	(UBYTE *)"2.54 mm",
	(UBYTE *)"1.27 mm",
	(UBYTE *)"0.635 mm",
	(UBYTE *)"5.0 mm",
	(UBYTE *)"2.0 mm",
	(UBYTE *)"1.0 mm",
	(UBYTE *)"0.8 mm",
	(UBYTE *)"0.65 mm",
	(UBYTE *)"custom",
	NULL };

UBYTE *EN_PlaceG15Labels[] = {
	(UBYTE *)"Center",
	(UBYTE *)"Above",
	(UBYTE *)"Below",
	(UBYTE *)"Left",
	(UBYTE *)"Right",
	(UBYTE *)"Custom",
	(UBYTE *)"None",
	NULL };

UBYTE *EN_ArcG15Labels[] = {
	(UBYTE *)"0",
	(UBYTE *)"90",
	(UBYTE *)"180",
	(UBYTE *)"270",
	NULL };

UBYTE *EN_KindG15Labels[] = {
	(UBYTE *)"Standard",
	(UBYTE *)"DIL",
	(UBYTE *)"SMD",
	(UBYTE *)"PGA",
	(UBYTE *)"PLCC",
	NULL };

UBYTE *EP_TypeG16Labels[] = {
	(UBYTE *)"Ellip",
	(UBYTE *)"4-Rect",
	NULL };

UBYTE *EP_LayerG16Labels[] = {
	(UBYTE *)"One",
	(UBYTE *)"Both",
	NULL };

UBYTE *EP_PlaceG16Labels[] = {
	(UBYTE *)"Center",
	(UBYTE *)"Above",
	(UBYTE *)"Below",
	(UBYTE *)"Left",
	(UBYTE *)"Right",
	(UBYTE *)"Custom",
	(UBYTE *)"None",
	NULL };

UBYTE *EP_ArcG16Labels[] = {
	(UBYTE *)"0",
	(UBYTE *)"90",
	(UBYTE *)"180",
	(UBYTE *)"270",
	NULL };

struct IntuiText PrintXIText[] = {
	1, 0, JAM1,42, 9, NULL, (UBYTE *)"Printer", NULL,
	1, 0, JAM1,54, 17, NULL, (UBYTE *)"Resolution", NULL,
	1, 0, JAM1,51, 25, NULL, (UBYTE *)"Max. Size", NULL };

#define PrintX_TNUM 3

struct IntuiText EditPadsIText[] = {
	1, 0, JAM1,20, 24, NULL, (UBYTE *)"1:", NULL };

#define EditPads_TNUM 1

struct IntuiText PrintingIText[] = {
	1, 0, JAM1,75, 12, NULL, (UBYTE *)"Hit 'Cancel' to ", NULL,
	1, 0, JAM1,69, 23, NULL, (UBYTE *)"stop printing", NULL,
	2, 0, JAM1,72, 11, NULL, (UBYTE *)"Hit 'Cancel' to", NULL,
	2, 0, JAM1,70, 22, NULL, (UBYTE *)"stop printing", NULL };

#define Printing_TNUM 4

struct IntuiText BuildPageIText[] = {
	1, 0, JAM1,66, 12, NULL, (UBYTE *)"Bulding Page", NULL,
	1, 0, JAM1,69, 25, NULL, (UBYTE *)"Please wait...", NULL,
	2, 0, JAM1,67, 11, NULL, (UBYTE *)"Bulding Page", NULL,
	2, 0, JAM1,70, 24, NULL, (UBYTE *)"Please wait...", NULL };

#define BuildPage_TNUM 4

struct IntuiText SpecialIText[] = {
	1, 0, JAM1,127, 10, NULL, (UBYTE *)"Before modifying ANY of this", NULL,
	1, 0, JAM1,127, 19, NULL, (UBYTE *)"Buttons, READ the doc files!", NULL,
	2, 0, JAM1,128, 9, NULL, (UBYTE *)"Before modifying ANY of this", NULL,
	2, 0, JAM1,128, 18, NULL, (UBYTE *)"Buttons, READ the doc files!", NULL };

#define Special_TNUM 4

struct IntuiText AboutIText[] = {
	1, 0, JAM1,319, 16, NULL, (UBYTE *)"A Program to develop Printed ", NULL,
	1, 0, JAM1,314, 26, NULL, (UBYTE *)"Ciriut Boards on the Amiga", NULL,
	1, 0, JAM1,315, 41, NULL, (UBYTE *)"(c) 1994 by Klaus Rotter", NULL,
	1, 0, JAM1,322, 51, NULL, (UBYTE *)"All rights reserved.", NULL,
	1, 0, JAM1,229, 131, NULL, (UBYTE *)"Do not distribute. This Version is only", NULL,
	1, 0, JAM1,224, 140, NULL, (UBYTE *)"for Beta-Testers", NULL,
	2, 0, JAM1,320, 15, NULL, (UBYTE *)"A Program to develop Printed ", NULL,
	2, 0, JAM1,315, 25, NULL, (UBYTE *)"Ciriut Boards on the Amiga", NULL,
	2, 0, JAM1,316, 40, NULL, (UBYTE *)"(c) 1994 by Klaus Rotter", NULL,
	2, 0, JAM1,323, 50, NULL, (UBYTE *)"All rights reserved.", NULL,
	2, 0, JAM1,230, 130, NULL, (UBYTE *)"Do not distribute. This Version is only", NULL,
	2, 0, JAM1,225, 139, NULL, (UBYTE *)"for Beta-Testers", NULL,
	1, 0, JAM1,148, 110, NULL, (UBYTE *)"Created using Matt Dillon's DICE", NULL,
	2, 0, JAM1,149, 109, NULL, (UBYTE *)"Created using Matt Dillon's DICE", NULL,
	1, 0, JAM1,289, 120, NULL, (UBYTE *)"and Jan van den Baard's GadToolsBox", NULL,
	2, 0, JAM1,290, 119, NULL, (UBYTE *)"and Jan van den Baard's GadToolsBox", NULL,
	1, 0, JAM1,269, 71, NULL, (UBYTE *)"Version:", NULL,
	1, 0, JAM1,266, 82, NULL, (UBYTE *)"Compiled:", NULL,
	2, 0, JAM1,270, 70, NULL, (UBYTE *)"Version:", NULL,
	2, 0, JAM1,267, 81, NULL, (UBYTE *)"Compiled:", NULL };

#define About_TNUM 20

struct IntuiText TraceLabelIText[] = {
	1, 0, JAM1,97, 9, NULL, (UBYTE *)"Traces", NULL,
	1, 0, JAM1,204, 9, NULL, (UBYTE *)"Labels", NULL };

#define TraceLabel_TNUM 2

struct NewMenu PlotNewMenu[] = {
	NM_TITLE, (STRPTR)"System", NULL, 0, NULL, NULL,
	NM_ITEM, (STRPTR)"About...", (STRPTR)"?", 0, 0L, NULL,
	NM_ITEM, (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"New...", (STRPTR)"N", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Board Prefs...", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Load...", (STRPTR)"L", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Save", (STRPTR)"S", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Save As...", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Save & Quit", (STRPTR)"X", 0, 0L, NULL,
	NM_ITEM, (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Print...", (STRPTR)"R", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"HPGL Plot...", (STRPTR)"O", NM_ITEMDISABLED, 0L, NULL,
	NM_ITEM, (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Quit", (STRPTR)"Q", 0, 0L, NULL,
	NM_TITLE, (STRPTR)"Edit", NULL, 0, NULL, NULL,
	NM_ITEM, (STRPTR)"Center", (STRPTR)"*", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Set Zero", (STRPTR)"0", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Set Size", (STRPTR)"-", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Areas", (STRPTR)",", 0, 0L, NULL,
	NM_TITLE, (STRPTR)"Part", NULL, 0, NULL, NULL,
	NM_ITEM, (STRPTR)"Label-Layer", NULL, CHECKIT|CHECKED|MENUTOGGLE, 0L, NULL,
	NM_ITEM, (STRPTR)"Compo-Layer", NULL, CHECKIT|CHECKED|MENUTOGGLE, 0L, NULL,
	NM_ITEM, (STRPTR)"Solder-Layer", NULL, CHECKIT|CHECKED|MENUTOGGLE, 0L, NULL,
	NM_ITEM, (STRPTR)"Pads", NULL, CHECKIT|CHECKED|MENUTOGGLE, 0L, NULL,
	NM_ITEM, (STRPTR)"Text", NULL, CHECKIT|CHECKED|MENUTOGGLE, 0L, NULL,
	NM_ITEM, (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Edit", (STRPTR)"E", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Rotate 90", (STRPTR)"9", 0, 0L, NULL,
	NM_ITEM, (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Load...", (STRPTR)"Y", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Save...", (STRPTR)"Z", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Library...", (STRPTR)"W", 0, 0L, NULL,
	NM_TITLE, (STRPTR)"Preferences", NULL, 0, NULL, NULL,
	NM_ITEM, (STRPTR)"Palette", (STRPTR)"P", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Screen", (STRPTR)"C", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Color", NULL, 0, NULL, NULL,
	NM_SUB, (STRPTR)"Grey-4", (STRPTR)"#", CHECKIT, 62L, NULL,
	NM_SUB, (STRPTR)"Grey-8", (STRPTR)"&", CHECKIT, 61L, NULL,
	NM_SUB, (STRPTR)"Color-8", (STRPTR)"+", CHECKIT|CHECKED, 59L, NULL,
	NM_SUB, (STRPTR)"Color-16", (STRPTR)"!", CHECKIT, 55L, NULL,
	NM_SUB, (STRPTR)"Color-256", (STRPTR)"$", CHECKIT, 47L, NULL,
	NM_SUB, (STRPTR)"Custom", (STRPTR)"%", CHECKIT, 31L, NULL,
	NM_ITEM, (STRPTR)"Font", (STRPTR)"T", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Trace & Label", (STRPTR)"G", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Pads", (STRPTR)"U", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Misc", (STRPTR)"I", 0, 0L, NULL,
	NM_ITEM, (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Load...", (STRPTR)"A", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Save...", (STRPTR)"B", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Save as default", (STRPTR)"H", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Default", (STRPTR)"D", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Standard", (STRPTR)"J", 0, 0L, NULL,
	NM_TITLE, (STRPTR)"Board", NULL, 0, NULL, NULL,
	NM_ITEM, (STRPTR)" <empty>", (STRPTR)"1", CHECKIT|CHECKED, 254L, NULL,
	NM_ITEM, (STRPTR)" <empty>", (STRPTR)"2", CHECKIT, 253L, NULL,
	NM_ITEM, (STRPTR)" <empty>", (STRPTR)"3", CHECKIT, 251L, NULL,
	NM_ITEM, (STRPTR)" <empty>", (STRPTR)"4", CHECKIT, 247L, NULL,
	NM_ITEM, (STRPTR)" <empty>", (STRPTR)"5", CHECKIT, 239L, NULL,
	NM_ITEM, (STRPTR)" <empty>", (STRPTR)"6", CHECKIT, 222L, NULL,
	NM_ITEM, (STRPTR)" <empty>", (STRPTR)"7", CHECKIT, 191L, NULL,
	NM_ITEM, (STRPTR)" <empty>", (STRPTR)"8", CHECKIT, 127L, NULL,
	NM_ITEM, (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Load all...", (STRPTR)"[", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Save all...", (STRPTR)"]", 0, 0L, NULL,
	NM_ITEM, (STRPTR)"New all...", (STRPTR)"/", 0, 0L, NULL,
	NM_TITLE, (STRPTR)"Elements", NULL, 0, NULL, NULL,
	NM_ITEM, (STRPTR)"Resitors", NULL, 0, NULL, NULL,
	NM_SUB, (STRPTR)"RM 1 (2.54mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 2 (5.04mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 3 (7.5mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 4 (10mm)", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Resitors-SMD", NULL, 0, NULL, NULL,
	NM_SUB, (STRPTR)"0402 (1.0x0.50)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"0805 (2.0x1.25)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"1206 (3.2x1.60)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"1210 (3.2x2.50)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"1808 (4.5x2.00)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"1812 (4.5x3.20)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"2220 (5.7x5.00)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"Poti (4.5x4.5)", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Potis", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Capacitors", NULL, 0, NULL, NULL,
	NM_SUB, (STRPTR)"RM 1 (2.54 mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 2 (5.08 mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 3 (7.5mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 4 (10mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 6 (15mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 9 (22.5mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"RM 11 (27.5mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"ELKO: 1.5mm", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"ELKO: 2.0mm", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"ELKO: 2.5mm", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"ELKO: 4.5mm", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"ELKO: 5mm", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Capacitors-SMD", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"LEDs", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"Transitors", NULL, 0, NULL, NULL,
	NM_SUB, (STRPTR)"TO-3", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"SOT-37", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"JEDEC TO-18", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"SOT-54", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"TO-126 (SOT-32)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"SOT-93", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"TO-220", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"SOT-103", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"DIP", NULL, 0, NULL, NULL,
	NM_SUB, (STRPTR)"8 Pin RM 7.62", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"14 Pin RM 7.62", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"16 Pin RM 7.62", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"18 Pin RM 7.62", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"20 Pin RM 7.62", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"22 Pin RM 7.62", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"22 Pin RM 10.16", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"24 Pin RM 7.62", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"24 Pin RM 10.16", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"24 Pin RM 15.24", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"28 Pin RM 15.24", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"32 Pin RM 15.24", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"40 Pin RM 15.24", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"64 Pin RM 22.86", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"PGA", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"PLCC", NULL, 0, NULL, NULL,
	NM_SUB, (STRPTR)" 20 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 24 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 28 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 44 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 52 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 68 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 84 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"100 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"124 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"156 Pin (1.27mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 44 Pin (0.635mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 52 Pin (0.635mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 68 Pin (0.635mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)" 84 Pin (0.635mm)", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"100 Pin (0.635mm)", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"PLCC-SMD", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"SMD: LEDs & Trans", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"SMD: ICs", NULL, 0, 0L, NULL,
	NM_ITEM, (STRPTR)"SMD: FlatPack", NULL, 0, NULL, NULL,
	NM_SUB, (STRPTR)"20 Pin", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"44 Pin", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"52 Pin", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"68 Pin", NULL, 0, 0L, NULL,
	NM_SUB, (STRPTR)"84 Pin", NULL, 0, 0L, NULL,
	NM_TITLE, (STRPTR)"Custom", NULL, 0, NULL, NULL,
	NM_ITEM, (STRPTR)" ", NULL, 0, 0L, NULL,
	NM_END, NULL, NULL, 0, 0L, NULL };

UWORD PlotGTypes[] = {
	BUTTON_KIND,
	BUTTON_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	STRING_KIND,
	CYCLE_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	BUTTON_KIND
};

UWORD PrintXGTypes[] = {
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	CYCLE_KIND,
	STRING_KIND,
	INTEGER_KIND,
	SLIDER_KIND,
	CYCLE_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	TEXT_KIND,
	TEXT_KIND,
	TEXT_KIND
};

UWORD GetPartGTypes[] = {
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	CHECKBOX_KIND
};

UWORD BoardPrefGTypes[] = {
	STRING_KIND,
	STRING_KIND,
	BUTTON_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	CHECKBOX_KIND,
	BUTTON_KIND,
	CHECKBOX_KIND,
	STRING_KIND,
	CYCLE_KIND
};

UWORD MiscGTypes[] = {
	BUTTON_KIND,
	BUTTON_KIND,
	INTEGER_KIND,
	CYCLE_KIND,
	STRING_KIND,
	INTEGER_KIND,
	BUTTON_KIND,
	STRING_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	BUTTON_KIND,
	TEXT_KIND,
	INTEGER_KIND
};

UWORD EditPadsGTypes[] = {
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

UWORD Step_mmGTypes[] = {
	CYCLE_KIND,
	STRING_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

UWORD Grid_mmGTypes[] = {
	CYCLE_KIND,
	STRING_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	CHECKBOX_KIND
};

UWORD PrintingGTypes[] = {
	BUTTON_KIND
};

UWORD PartsLibGTypes[] = {
	LISTVIEW_KIND,
	STRING_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

UWORD BuildPageGTypes[] = {
	TEXT_KIND
};

UWORD SpecialGTypes[] = {
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	CHECKBOX_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

UWORD AboutGTypes[] = {
	BUTTON_KIND,
	TEXT_KIND,
	TEXT_KIND,
	TEXT_KIND
};

UWORD TraceLabelGTypes[] = {
	STRING_KIND,
	STRING_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND
};

UWORD PaletteGTypes[] = {
	PALETTE_KIND,
	SLIDER_KIND,
	SLIDER_KIND,
	SLIDER_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

UWORD EditNameGTypes[] = {
	STRING_KIND,
	STRING_KIND,
	CYCLE_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	CYCLE_KIND,
	BUTTON_KIND,
	CYCLE_KIND
};

UWORD EditSinglePadGTypes[] = {
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	CYCLE_KIND,
	CYCLE_KIND,
	CHECKBOX_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	STRING_KIND,
	STRING_KIND,
	CYCLE_KIND,
	CYCLE_KIND
};

struct NewGadget PlotNGad[] = {
	12, 106, 101, 14, (UBYTE *)"_Plot", NULL, GD_Pl_PlotG, PLACETEXT_IN, NULL, NULL,
	195, 106, 101, 14, (UBYTE *)"_Cancel", NULL, GD_Pl_CancelG, PLACETEXT_IN, NULL, NULL,
	181, 27, 26, 11, (UBYTE *)"_Mirror", NULL, GD_Pl_MirrorG, PLACETEXT_RIGHT, NULL, NULL,
	181, 39, 26, 11, (UBYTE *)"Sho_w Hole", NULL, GD_Pl_ShowHoleG, PLACETEXT_RIGHT, NULL, NULL,
	80, 10, 174, 14, (UBYTE *)"_Device", NULL, GD_Pl_FileNameG, PLACETEXT_LEFT, NULL, NULL,
	181, 81, 106, 14, NULL, NULL, GD_Pl_ZoomG, 0, NULL, NULL,
	22, 27, 26, 11, (UBYTE *)"_Label Layer", NULL, GD_Pl_LabelG, PLACETEXT_RIGHT, NULL, NULL,
	22, 75, 26, 11, (UBYTE *)"Dr_ill", NULL, GD_Pl_DrillG, PLACETEXT_RIGHT, NULL, NULL,
	22, 39, 26, 11, (UBYTE *)"_Component Layer", NULL, GD_Pl_CompoG, PLACETEXT_RIGHT, NULL, NULL,
	22, 51, 26, 11, (UBYTE *)"_Solder Layer", NULL, GD_Pl_SolderG, PLACETEXT_RIGHT, NULL, NULL,
	22, 63, 26, 11, (UBYTE *)"_Pad", NULL, GD_Pl_PadG, PLACETEXT_RIGHT, NULL, NULL,
	22, 87, 26, 11, (UBYTE *)"_Areas", NULL, GD_Pl_AreasG, PLACETEXT_RIGHT, NULL, NULL,
	257, 10, 31, 14, (UBYTE *)"_Get", NULL, GD_Pl_GetG, PLACETEXT_IN, NULL, NULL
};

struct NewGadget PrintXNGad[] = {
	178, 39, 26, 11, (UBYTE *)"_Mirror", NULL, GD_Pr_MirrorG, PLACETEXT_RIGHT, NULL, NULL,
	178, 51, 26, 11, (UBYTE *)"Sho_w Hole", NULL, GD_Pr_ShowHoleG, PLACETEXT_RIGHT, NULL, NULL,
	178, 63, 26, 11, (UBYTE *)"_Form Feed", NULL, GD_Pr_FormFeedG, PLACETEXT_RIGHT, NULL, NULL,
	178, 75, 26, 11, (UBYTE *)"_Inverse", NULL, GD_Pr_InverseG, PLACETEXT_RIGHT, NULL, NULL,
	7, 155, 81, 14, (UBYTE *)"_Print", NULL, GD_Pr_PrintG, PLACETEXT_IN, NULL, NULL,
	213, 155, 81, 14, (UBYTE *)"_Cancel", NULL, GD_Pr_CancelG, PLACETEXT_IN, NULL, NULL,
	110, 155, 81, 14, (UBYTE *)"_Show", NULL, GD_Pr_ShowG, PLACETEXT_IN, NULL, NULL,
	178, 87, 106, 14, NULL, NULL, GD_Pr_ZoomG, 0, NULL, NULL,
	193, 135, 92, 13, (UBYTE *)"Do_t ", NULL, GD_Pr_DotG, PLACETEXT_LEFT, NULL, NULL,
	70, 136, 67, 12, (UBYTE *)"Li_nes", NULL, GD_Pr_LineG, PLACETEXT_LEFT, NULL, NULL,
	220, 120, 65, 13, (UBYTE *)"_Density  ", NULL, GD_Pr_DensityG, PLACETEXT_LEFT, NULL, NULL,
	14, 120, 123, 14, NULL, NULL, GD_Pr_AspectG, 0, NULL, NULL,
	14, 39, 26, 11, (UBYTE *)"_Label Layer", NULL, GD_Pr_LabelG, PLACETEXT_RIGHT, NULL, NULL,
	14, 87, 26, 11, (UBYTE *)"D_rill", NULL, GD_Pr_DrillG, PLACETEXT_RIGHT, NULL, NULL,
	14, 51, 26, 11, (UBYTE *)"_Component Layer", NULL, GD_Pr_CompoG, PLACETEXT_RIGHT, NULL, NULL,
	14, 63, 26, 11, (UBYTE *)"_Solder Layer", NULL, GD_Pr_SolderG, PLACETEXT_RIGHT, NULL, NULL,
	14, 75, 26, 11, (UBYTE *)"_Pad", NULL, GD_Pr_PadG, PLACETEXT_RIGHT, NULL, NULL,
	14, 99, 26, 11, (UBYTE *)"_Areas", NULL, GD_Pr_AreasG, PLACETEXT_RIGHT, NULL, NULL,
	109, 3, 178, 11, NULL, NULL, GD_Pr_PrinterG, 0, NULL, NULL,
	109, 11, 178, 11, NULL, NULL, GD_Pr_ResolutionG, 0, NULL, NULL,
	109, 19, 178, 11, NULL, NULL, GD_Pr_SizeG, 0, NULL, NULL
};

struct NewGadget GetPartNGad[] = {
	44, 8, 26, 11, (UBYTE *)"_Label Layer", NULL, GD_GP_LabelG, PLACETEXT_RIGHT, NULL, NULL,
	44, 20, 26, 11, (UBYTE *)"Co_mponent Layer", NULL, GD_GP_ComponentG, PLACETEXT_RIGHT, NULL, NULL,
	44, 32, 26, 11, (UBYTE *)"_Solder Layer", NULL, GD_GP_SolderG, PLACETEXT_RIGHT, NULL, NULL,
	44, 44, 26, 11, (UBYTE *)"_Pad", NULL, GD_GP_PadG, PLACETEXT_RIGHT, NULL, NULL,
	14, 107, 92, 15, (UBYTE *)"_OK", NULL, GD_GP_OkG, PLACETEXT_IN, NULL, NULL,
	135, 107, 92, 15, (UBYTE *)"_Cancel", NULL, GD_GP_CancelG, PLACETEXT_IN, NULL, NULL,
	31, 69, 177, 13, (UBYTE *)"_Add active layer", NULL, GD_GP_AddLayerG, PLACETEXT_IN, NULL, NULL,
	31, 84, 177, 13, (UBYTE *)"Only a_ctive layer", NULL, GD_GP_OnlyLayerG, PLACETEXT_IN, NULL, NULL,
	45, 56, 26, 11, (UBYTE *)"_No Text", NULL, GD_GP_NoTextG, PLACETEXT_RIGHT, NULL, NULL
};

struct NewGadget BoardPrefNGad[] = {
	122, 98, 133, 14, (UBYTE *)"Total _Width", NULL, GD_BP_WidthG, PLACETEXT_LEFT, NULL, NULL,
	122, 113, 133, 14, (UBYTE *)"Total _Height", NULL, GD_BP_HeightG, PLACETEXT_LEFT, NULL, NULL,
	4, 149, 91, 14, (UBYTE *)"_OK", NULL, GD_BP_OkG, PLACETEXT_IN, NULL, NULL,
	122, 8, 201, 14, (UBYTE *)"_Project", NULL, GD_BP_ProjectG, PLACETEXT_LEFT, NULL, NULL,
	122, 38, 201, 14, (UBYTE *)"_Author", NULL, GD_BP_AuthorG, PLACETEXT_LEFT, NULL, NULL,
	122, 53, 201, 14, (UBYTE *)"Co_mpany", NULL, GD_BP_CompanyG, PLACETEXT_LEFT, NULL, NULL,
	122, 68, 101, 14, (UBYTE *)"C_reated", NULL, GD_BP_Created, PLACETEXT_LEFT, NULL, NULL,
	122, 83, 101, 14, (UBYTE *)"La_st Change", NULL, GD_BP_LastChG, PLACETEXT_LEFT, NULL, NULL,
	228, 84, 26, 11, (UBYTE *)"A_uto", NULL, GD_BP_AutoG, PLACETEXT_RIGHT, NULL, NULL,
	237, 149, 91, 13, (UBYTE *)"_Cancel", NULL, GD_BP_CancelG, PLACETEXT_IN, NULL, NULL,
	122, 130, 26, 11, (UBYTE *)"Sa_ve Config", NULL, GD_P_SaveConfigG, PLACETEXT_LEFT, NULL, NULL,
	122, 23, 201, 14, (UBYTE *)"Par_t", NULL, GD_BP_PartG, PLACETEXT_LEFT, NULL, NULL,
	158, 128, 96, 15, NULL, NULL, GD_BP_OutfitG, 0, NULL, NULL
};

struct NewGadget MiscNGad[] = {
	11, 163, 77, 14, (UBYTE *)"_OK", NULL, GD_MC_OkG, PLACETEXT_IN, NULL, NULL,
	177, 163, 77, 14, (UBYTE *)"_Cancel", NULL, GD_MC_CancelG, PLACETEXT_IN, NULL, NULL,
	118, 7, 51, 13, (UBYTE *)"_Base DPI", NULL, GD_MC_BaseG, PLACETEXT_LEFT, NULL, NULL,
	118, 52, 128, 13, (UBYTE *)"_Units", NULL, GD_MC_CoordsG, PLACETEXT_LEFT, NULL, NULL,
	118, 21, 51, 13, (UBYTE *)"_Aspect", NULL, GD_MC_AspectG, PLACETEXT_LEFT, NULL, NULL,
	118, 36, 51, 13, (UBYTE *)"_Resolution", NULL, GD_MC_ResolutionG, PLACETEXT_LEFT, NULL, NULL,
	172, 7, 70, 27, (UBYTE *)"Ca_lc", NULL, GD_MC_CalcG, PLACETEXT_IN, NULL, NULL,
	118, 82, 128, 13, (UBYTE *)"_Default Dir", NULL, GD_MC_DefaultDirG, PLACETEXT_LEFT, NULL, NULL,
	139, 126, 106, 13, (UBYTE *)"Draw Lab_el", NULL, GD_MC_DrawLabel, PLACETEXT_LEFT, NULL, NULL,
	139, 112, 106, 13, (UBYTE *)"Draw _Traces", NULL, GD_MC_DrawTracesG, PLACETEXT_LEFT, NULL, NULL,
	139, 98, 106, 13, (UBYTE *)"Draw _Pads", NULL, GD_MC_DrawPadsG, PLACETEXT_LEFT, NULL, NULL,
	139, 141, 106, 13, (UBYTE *)"Special", NULL, GD_MC_SpecialG, PLACETEXT_IN, NULL, NULL,
	173, 37, 69, 12, NULL, NULL, GD_Gadget134, 0, NULL, NULL,
	118, 68, 128, 13, (UBYTE *)"_Scroll %", NULL, GD_Gadget144, PLACETEXT_LEFT, NULL, NULL
};

struct NewGadget EditPadsNGad[] = {
	38, 76, 49, 14, (UBYTE *)"5:", NULL, GD_EP_A5G, PLACETEXT_LEFT, NULL, NULL,
	92, 76, 50, 14, NULL, NULL, GD_EP_B5G, 0, NULL, NULL,
	146, 76, 50, 14, NULL, NULL, GD_EP_H5G, 0, NULL, NULL,
	38, 91, 49, 14, (UBYTE *)"6:", NULL, GD_EP_A6G, PLACETEXT_LEFT, NULL, NULL,
	91, 91, 51, 14, NULL, NULL, GD_EP_B6G, 0, NULL, NULL,
	145, 91, 51, 14, NULL, NULL, GD_EP_H6G, 0, NULL, NULL,
	37, 106, 51, 14, (UBYTE *)"7:", NULL, GD_EP_A7G, PLACETEXT_LEFT, NULL, NULL,
	91, 106, 51, 14, NULL, NULL, GD_EP_B7G, 0, NULL, NULL,
	145, 106, 51, 14, NULL, NULL, GD_EP_H7G, 0, NULL, NULL,
	37, 121, 51, 14, (UBYTE *)"8:", NULL, GD_EP_A8G, PLACETEXT_LEFT, NULL, NULL,
	91, 121, 51, 14, NULL, NULL, GD_EP_B8G, 0, NULL, NULL,
	145, 121, 51, 14, NULL, NULL, GD_EP_H8G, 0, NULL, NULL,
	37, 16, 51, 14, (UBYTE *)"horiz", NULL, GD_EP_A1G, PLACETEXT_ABOVE, NULL, NULL,
	91, 16, 51, 14, (UBYTE *)"vert", NULL, GD_EP_B1G, PLACETEXT_ABOVE, NULL, NULL,
	145, 16, 51, 14, (UBYTE *)"hole", NULL, GD_EP_H1G, PLACETEXT_ABOVE, NULL, NULL,
	36, 31, 51, 14, (UBYTE *)"2:", NULL, GD_EP_A2G, PLACETEXT_LEFT, NULL, NULL,
	91, 31, 51, 14, NULL, NULL, GD_EP_B2G, 0, NULL, NULL,
	145, 31, 51, 14, NULL, NULL, GD_EP_H2G, 0, NULL, NULL,
	37, 46, 51, 14, (UBYTE *)"3:", NULL, GD_EP_A3G, PLACETEXT_LEFT, NULL, NULL,
	91, 46, 51, 14, NULL, NULL, GD_EP_B3G, 0, NULL, NULL,
	145, 46, 51, 14, NULL, NULL, GD_EP_H3G, 0, NULL, NULL,
	38, 61, 51, 14, (UBYTE *)"4:", NULL, GD_EP_A4G, PLACETEXT_LEFT, NULL, NULL,
	92, 61, 51, 14, NULL, NULL, GD_EP_B4G, 0, NULL, NULL,
	146, 61, 51, 14, NULL, NULL, GD_EP_H4G, 0, NULL, NULL,
	37, 136, 51, 14, (UBYTE *)"9:", NULL, GD_EP_A9G, PLACETEXT_LEFT, NULL, NULL,
	91, 136, 51, 14, NULL, NULL, GD_EP_B9G, 0, NULL, NULL,
	145, 136, 51, 14, NULL, NULL, GD_EP_H9G, 0, NULL, NULL,
	37, 151, 51, 14, (UBYTE *)"0:", NULL, GD_EP_A0G, PLACETEXT_LEFT, NULL, NULL,
	91, 151, 51, 14, NULL, NULL, GD_EP_B0G, 0, NULL, NULL,
	145, 151, 51, 14, NULL, NULL, GD_EP_H0G, 0, NULL, NULL,
	199, 16, 76, 14, (UBYTE *)"Type", NULL, GD_EP_Type1G, PLACETEXT_ABOVE, NULL, NULL,
	199, 31, 76, 14, NULL, NULL, GD_EP_Type2G, 0, NULL, NULL,
	199, 46, 76, 14, NULL, NULL, GD_EP_Type3G, 0, NULL, NULL,
	200, 61, 76, 14, NULL, NULL, GD_EP_Type4G, 0, NULL, NULL,
	202, 76, 74, 14, NULL, NULL, GD_EP_Type5G, 0, NULL, NULL,
	199, 91, 76, 14, NULL, NULL, GD_EP_Type6G, 0, NULL, NULL,
	199, 106, 76, 14, NULL, NULL, GD_EP_Type7G, 0, NULL, NULL,
	199, 121, 76, 14, NULL, NULL, GD_EP_Type8G, 0, NULL, NULL,
	199, 136, 76, 14, NULL, NULL, GD_EP_Type9G, 0, NULL, NULL,
	199, 151, 76, 14, NULL, NULL, GD_EP_Type0G, 0, NULL, NULL,
	279, 16, 76, 14, (UBYTE *)"Layer", NULL, GD_EP_Layer1G, PLACETEXT_ABOVE, NULL, NULL,
	279, 31, 76, 14, NULL, NULL, GD_EP_Layer2G, 0, NULL, NULL,
	279, 46, 76, 14, NULL, NULL, GD_EP_Layer3G, 0, NULL, NULL,
	280, 61, 76, 14, NULL, NULL, GD_EP_Layer4G, 0, NULL, NULL,
	280, 76, 74, 14, NULL, NULL, GD_EP_Layer5G, 0, NULL, NULL,
	279, 91, 76, 14, NULL, NULL, GD_EP_Layer6G, 0, NULL, NULL,
	279, 106, 76, 14, NULL, NULL, GD_EP_Layer7G, 0, NULL, NULL,
	279, 121, 76, 14, NULL, NULL, GD_EP_Layer8G, 0, NULL, NULL,
	279, 136, 76, 14, NULL, NULL, GD_EP_Layer9G, 0, NULL, NULL,
	279, 151, 76, 14, NULL, NULL, GD_EP_Layer0G, 0, NULL, NULL,
	360, 17, 26, 11, (UBYTE *)"Hole", NULL, GD_EP_Hole1G, PLACETEXT_ABOVE, NULL, NULL,
	360, 32, 26, 11, NULL, NULL, GD_EP_Hole2G, 0, NULL, NULL,
	360, 47, 26, 11, NULL, NULL, GD_EP_Hole3G, 0, NULL, NULL,
	361, 62, 26, 11, NULL, NULL, GD_EP_Hole4G, 0, NULL, NULL,
	359, 77, 26, 11, NULL, NULL, GD_EP_Hole5G, 0, NULL, NULL,
	360, 92, 26, 11, NULL, NULL, GD_EP_Hole6G, 0, NULL, NULL,
	360, 107, 26, 11, NULL, NULL, GD_EP_Hole7G, 0, NULL, NULL,
	360, 122, 26, 11, NULL, NULL, GD_EP_Hole8G, 0, NULL, NULL,
	360, 137, 26, 11, NULL, NULL, GD_EP_Hole9G, 0, NULL, NULL,
	360, 152, 26, 11, NULL, NULL, GD_EP_Hole0G, 0, NULL, NULL,
	7, 171, 91, 12, (UBYTE *)"_OK", NULL, GD_EP_OkG, PLACETEXT_IN, NULL, NULL,
	307, 171, 91, 12, (UBYTE *)"_Cancel", NULL, GD_EP_CancelG, PLACETEXT_IN, NULL, NULL,
	157, 171, 91, 12, (UBYTE *)"_Undo", NULL, GD_EP_UndoG, PLACETEXT_IN, NULL, NULL
};

struct NewGadget Step_mmNGad[] = {
	72, 9, 129, 14, (UBYTE *)"_Step:", NULL, GD_CS_StepG, PLACETEXT_LEFT, NULL, NULL,
	72, 25, 129, 14, (UBYTE *)"C_ustom", NULL, GD_CS_CustomG, PLACETEXT_LEFT, NULL, NULL,
	6, 46, 81, 12, (UBYTE *)"_OK", NULL, GD_CS_OkG, PLACETEXT_IN, NULL, NULL,
	139, 46, 81, 12, (UBYTE *)"_Cancel", NULL, GD_CS_CancelG, PLACETEXT_IN, NULL, NULL
};

struct NewGadget Grid_mmNGad[] = {
	72, 9, 129, 14, (UBYTE *)"_Grid:", NULL, GD_CG_GridG, PLACETEXT_LEFT, NULL, NULL,
	72, 25, 129, 14, (UBYTE *)"C_ustom", NULL, GD_CG_CustomG, PLACETEXT_LEFT, NULL, NULL,
	7, 59, 81, 13, (UBYTE *)"_OK", NULL, GD_CG_OkG, PLACETEXT_IN, NULL, NULL,
	135, 59, 81, 13, (UBYTE *)"_Cancel", NULL, GD_CG_CancelG, PLACETEXT_IN, NULL, NULL,
	145, 41, 26, 11, (UBYTE *)"G_rid on:", NULL, GD_CG_GridOnG, PLACETEXT_LEFT, NULL, NULL
};

struct NewGadget PrintingNGad[] = {
	9, 33, 125, 15, (UBYTE *)"_Cancel", NULL, GD_PI_CancelG, PLACETEXT_IN, NULL, NULL
};

struct NewGadget PartsLibNGad[] = {
	18, 37, 206, 136, NULL, NULL, GD_Li_PartsG, 0, NULL, NULL,
	87, 6, 242, 14, (UBYTE *)"Library", NULL, GD_Li_LibraryG, PLACETEXT_LEFT, NULL, NULL,
	18, 22, 94, 12, (UBYTE *)"Open Lib", NULL, GD_Li_GetG, PLACETEXT_IN, NULL, NULL,
	227, 37, 101, 12, (UBYTE *)"_Load", NULL, GD_Li_LoadG, PLACETEXT_IN, NULL, NULL,
	227, 50, 101, 12, (UBYTE *)"_Save", NULL, GD_Li_SaveG, PLACETEXT_IN, NULL, NULL,
	227, 63, 101, 12, (UBYTE *)"_Ed -> Lib", NULL, GD_Li_EdLibG, PLACETEXT_IN, NULL, NULL,
	227, 76, 101, 12, (UBYTE *)"L_ib -> Ed", NULL, GD_Li_LibEdG, PLACETEXT_IN, NULL, NULL,
	227, 89, 101, 12, (UBYTE *)"Edi_tor", NULL, GD_Gadget89, PLACETEXT_IN, NULL, NULL,
	227, 102, 101, 12, (UBYTE *)"_Delete", NULL, GD_Li_DeleteG, PLACETEXT_IN, NULL, NULL,
	227, 115, 101, 12, (UBYTE *)"_Rename", NULL, GD_Li_RenameG, PLACETEXT_IN, NULL, NULL,
	127, 22, 94, 12, (UBYTE *)"Save Lib", NULL, GD_Li_SaveLibG, PLACETEXT_IN, NULL, NULL,
	235, 22, 94, 12, (UBYTE *)"Close Lib", NULL, GD_Li_CloseLibG, PLACETEXT_IN, NULL, NULL,
	227, 158, 101, 15, (UBYTE *)"OK", NULL, GD_Li_OkG, PLACETEXT_IN, NULL, NULL
};

struct NewGadget BuildPageNGad[] = {
	106, 12, 34, 12, NULL, NULL, GD_Gadg11, 0, NULL, NULL
};

struct NewGadget SpecialNGad[] = {
	187, 27, 26, 11, (UBYTE *)"Use Area*()", NULL, GD_MC_UseAreaG, PLACETEXT_LEFT, NULL, NULL,
	187, 39, 26, 11, (UBYTE *)"Use ScrollRaster()", NULL, GD_MC_UseScrollG, PLACETEXT_LEFT, NULL, NULL,
	187, 51, 26, 11, (UBYTE *)"Use BlitBitMap()", NULL, GD_MC_UseBlitG, PLACETEXT_LEFT, NULL, NULL,
	187, 63, 26, 11, (UBYTE *)"Use SetWrMsk()", NULL, GD_MC_UserWrtMskG, PLACETEXT_LEFT, NULL, NULL,
	7, 83, 71, 13, (UBYTE *)"_OK", NULL, GD_Gadget511, PLACETEXT_IN, NULL, NULL,
	176, 83, 71, 13, (UBYTE *)"_Cancel", NULL, GD_Gadget611, PLACETEXT_IN, NULL, NULL
};

struct NewGadget AboutNGad[] = {
	156, 152, 137, 14, (UBYTE *)"_More", NULL, GD_Ab_MoreG, PLACETEXT_IN, NULL, NULL,
	306, 64, 94, 14, NULL, NULL, GD_Ab_VersionG, 0, NULL, NULL,
	306, 75, 94, 14, NULL, NULL, GD_Ab_DateG, 0, NULL, NULL,
	306, 86, 94, 14, NULL, NULL, GD_Ab_TimeG, 0, NULL, NULL
};

struct NewGadget TraceLabelNGad[] = {
	48, 14, 101, 12, (UBYTE *)"1:", NULL, GD_TL_Trace1G, PLACETEXT_LEFT, NULL, NULL,
	156, 14, 101, 12, NULL, NULL, GD_TL_Label1G, 0, NULL, NULL,
	9, 149, 83, 12, (UBYTE *)"_OK", NULL, GD_TL_OkG, PLACETEXT_IN, NULL, NULL,
	194, 149, 83, 12, (UBYTE *)"_Cancel", NULL, GD_TL_CancelG, PLACETEXT_IN, NULL, NULL,
	48, 27, 101, 12, (UBYTE *)"2:", NULL, GD_TL_Trace2G, PLACETEXT_LEFT, NULL, NULL,
	48, 40, 101, 12, (UBYTE *)"3:", NULL, GD_TL_Trace3G, PLACETEXT_LEFT, NULL, NULL,
	48, 53, 101, 12, (UBYTE *)"4:", NULL, GD_TL_Trace4G, PLACETEXT_LEFT, NULL, NULL,
	48, 66, 101, 12, (UBYTE *)"5:", NULL, GD_TL_Trace5G, PLACETEXT_LEFT, NULL, NULL,
	48, 79, 101, 12, (UBYTE *)"6:", NULL, GD_TL_Trace6G, PLACETEXT_LEFT, NULL, NULL,
	48, 92, 101, 12, (UBYTE *)"7:", NULL, GD_TL_Trace7G, PLACETEXT_LEFT, NULL, NULL,
	48, 105, 101, 12, (UBYTE *)"8:", NULL, GD_TL_Trace8G, PLACETEXT_LEFT, NULL, NULL,
	48, 118, 101, 12, (UBYTE *)"9:", NULL, GD_TL_Trace9G, PLACETEXT_LEFT, NULL, NULL,
	48, 131, 101, 12, (UBYTE *)"0:", NULL, GD_TL_Trace0G, PLACETEXT_LEFT, NULL, NULL,
	156, 27, 101, 12, NULL, NULL, GD_TL_Label2G, 0, NULL, NULL,
	156, 40, 101, 12, NULL, NULL, GD_TL_Label3G, 0, NULL, NULL,
	156, 53, 101, 12, NULL, NULL, GD_TL_Label4G, 0, NULL, NULL,
	156, 66, 101, 12, NULL, NULL, GD_TL_Label5G, 0, NULL, NULL,
	156, 79, 101, 12, NULL, NULL, GD_TL_Label6G, 0, NULL, NULL,
	156, 92, 101, 12, NULL, NULL, GD_TL_Label7G, 0, NULL, NULL,
	156, 105, 101, 12, NULL, NULL, GD_TL_Label8G, 0, NULL, NULL,
	156, 118, 101, 12, NULL, NULL, GD_TL_Label9G, 0, NULL, NULL,
	156, 131, 101, 12, NULL, NULL, GD_TL_Label0G, 0, NULL, NULL
};

struct NewGadget PaletteNGad[] = {
	89, 8, 267, 23, NULL, NULL, GD_Gadget014, 0, NULL, NULL,
	90, 34, 247, 9, (UBYTE *)"_Red", NULL, GD_Gadget114, PLACETEXT_LEFT, NULL, NULL,
	90, 44, 247, 9, (UBYTE *)"_Green", NULL, GD_Gadget214, PLACETEXT_LEFT, NULL, NULL,
	90, 54, 247, 9, (UBYTE *)"_Blue", NULL, GD_Gadget314, PLACETEXT_LEFT, NULL, NULL,
	11, 75, 101, 14, (UBYTE *)"_Ok", NULL, GD_Gadget414, PLACETEXT_IN, NULL, NULL,
	268, 75, 101, 14, (UBYTE *)"_Cancel", NULL, GD_Gadget514, PLACETEXT_IN, NULL, NULL
};

struct NewGadget EditNameNGad[] = {
	79, 8, 101, 14, (UBYTE *)"_ID   :", NULL, GD_EN_IDG, PLACETEXT_LEFT, NULL, NULL,
	79, 24, 101, 14, (UBYTE *)"_Name :", NULL, GD_EN_NameG, PLACETEXT_LEFT, NULL, NULL,
	190, 8, 86, 14, NULL, NULL, GD_EN_PlaceG, 0, NULL, NULL,
	11, 47, 81, 14, (UBYTE *)"_Ok", NULL, GD_EN_OkG, PLACETEXT_IN, NULL, NULL,
	266, 47, 81, 14, (UBYTE *)"_Cancel", NULL, GD_EN_CancelG, PLACETEXT_IN, NULL, NULL,
	279, 8, 58, 14, NULL, NULL, GD_EN_ArcG, 0, NULL, NULL,
	138, 47, 81, 14, (UBYTE *)"_Edit", NULL, GD_EN_EditG, PLACETEXT_IN, NULL, NULL,
	190, 24, 146, 14, NULL, NULL, GD_EN_KindG, 0, NULL, NULL
};

struct NewGadget EditSinglePadNGad[] = {
	84, 41, 101, 14, (UBYTE *)"_Horiz :", NULL, GD_EP_HorizG, PLACETEXT_LEFT, NULL, NULL,
	84, 57, 101, 14, (UBYTE *)"_Vert  :", NULL, GD_EP_VertG, PLACETEXT_LEFT, NULL, NULL,
	84, 73, 101, 14, (UBYTE *)"Ho_le  :", NULL, GD_EP_HoleG, PLACETEXT_LEFT, NULL, NULL,
	269, 41, 84, 14, (UBYTE *)"_Type  :", NULL, GD_EP_TypeG, PLACETEXT_LEFT, NULL, NULL,
	269, 57, 84, 14, (UBYTE *)"La_yer :", NULL, GD_EP_LayerG, PLACETEXT_LEFT, NULL, NULL,
	277, 73, 26, 11, (UBYTE *)"Hol_e  : ", NULL, GD_EP_HoleFlagG, PLACETEXT_LEFT, NULL, NULL,
	10, 95, 81, 12, (UBYTE *)"_OK", NULL, GD_EP_OkG, PLACETEXT_IN, NULL, NULL,
	286, 95, 81, 12, (UBYTE *)"_Cancel", NULL, GD_EP_CancelG, PLACETEXT_IN, NULL, NULL,
	148, 95, 81, 12, (UBYTE *)"_Undo", NULL, GD_EP_UndoG, PLACETEXT_IN, NULL, NULL,
	84, 9, 101, 14, (UBYTE *)"_ID   :", NULL, GD_EP_IDG, PLACETEXT_LEFT, NULL, NULL,
	84, 25, 101, 14, (UBYTE *)"_Name :", NULL, GD_EP_NameG, PLACETEXT_LEFT, NULL, NULL,
	269, 9, 86, 14, (UBYTE *)"ID _Pos :", NULL, GD_EP_PlaceG, PLACETEXT_LEFT, NULL, NULL,
	269, 25, 58, 14, (UBYTE *)"ID _Arc :", NULL, GD_EP_ArcG, PLACETEXT_LEFT, NULL, NULL
};

ULONG PlotGTags[] = {
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTST_String), (ULONG)"PLT:", (GTST_MaxChars), 256, (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&Pl_ZoomG0Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE)
};

ULONG PrintXGTags[] = {
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&Pr_ZoomG1Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE),
	(GTST_String), (ULONG)"0.2 mm", (GTST_MaxChars), 256, (GT_Underscore), '_', (TAG_DONE),
	(GTIN_Number), 960, (GTIN_MaxChars), 10, (GT_Underscore), '_', (TAG_DONE),
	(GTSL_Min), 1, (GTSL_Max), 7, (GTSL_Level), 7, (GTSL_MaxLevelLen), 7, (GTSL_LevelFormat), (ULONG)"%ld", (PGA_Freedom), LORIENT_HORIZ, (GA_RelVerify), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&Pr_AspectG1Labels[ 0 ], (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTTX_Text), (ULONG)"None", (TAG_DONE),
	(GTTX_Text), (ULONG)"0x0 dpi", (TAG_DONE),
	(GTTX_Text), (ULONG)"0x0 dpi", (TAG_DONE)
};

ULONG GetPartGTags[] = {
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE)
};

ULONG BoardPrefGTags[] = {
	(GTST_String), (ULONG)"160 mm", (GTST_MaxChars), 256, (GT_Underscore), '_', (TAG_DONE),
	(GTST_String), (ULONG)"100 mm", (GTST_MaxChars), 256, (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 30, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 30, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 30, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 8, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 8, (GT_Underscore), '_', (TAG_DONE),
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 30, (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&BP_OutfitG3Labels[ 0 ], (TAG_DONE)
};

ULONG MiscGTags[] = {
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTIN_Number), 160, (GTIN_MaxChars), 4, (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&MC_CoordsG4Labels[ 0 ], (GTCY_Active), 1, (GT_Underscore), '_', (TAG_DONE),
	(GTST_String), (ULONG)"1", (GTST_MaxChars), 256, (GT_Underscore), '_', (TAG_DONE),
	(GTIN_Number), 1600, (GTIN_MaxChars), 10, (GT_Underscore), '_', (GA_Disabled), TRUE, (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 30, (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&MC_DrawLabel4Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&MC_DrawTracesG4Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&MC_DrawPadsG4Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE),
	(TAG_DONE),
	(GTTX_Text), (ULONG)"520x520mm", (TAG_DONE),
	(GTIN_Number), 50, (GTIN_MaxChars), 10, (GT_Underscore), '_', (TAG_DONE)
};

ULONG EditPadsGTags[] = {
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTST_MaxChars), 10, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type1G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type2G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type3G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type4G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type5G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type6G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type7G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type8G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type9G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Type0G5Labels[ 0 ], (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer1G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer2G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer3G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer4G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer5G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer6G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer7G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer8G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer9G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_Layer0G5Labels[ 0 ], (GTCY_Active), 1, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE)
};

ULONG Step_mmGTags[] = {
	(GTCY_Labels), (ULONG)&CS_StepG6Labels[ 0 ], (GTCY_Active), 1, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 256, (GT_Underscore), '_', (GA_Disabled), TRUE, (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE)
};

ULONG Grid_mmGTags[] = {
	(GTCY_Labels), (ULONG)&CG_GridG7Labels[ 0 ], (GTCY_Active), 1, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 256, (GT_Underscore), '_', (GA_Disabled), TRUE, (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE)
};

ULONG PrintingGTags[] = {
	(GT_Underscore), '_', (TAG_DONE)
};

ULONG PartsLibGTags[] = {
	(GTLV_ShowSelected), NULL, (TAG_DONE),
	(GTST_MaxChars), 256, (TAG_DONE),
	(TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(TAG_DONE),
	(TAG_DONE),
	(TAG_DONE)
};

ULONG BuildPageGTags[] = {
	(GTTX_Text), (ULONG)" ", (TAG_DONE)
};

ULONG SpecialGTags[] = {
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (GA_Disabled), TRUE, (TAG_DONE),
	(GTCB_Checked), TRUE, (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE)
};

ULONG AboutGTags[] = {
	(GT_Underscore), '_', (TAG_DONE),
	(GTTX_Text), (ULONG)"0.01 alpha", (TAG_DONE),
	(GTTX_Text), (ULONG)"1 Dez 1993", (TAG_DONE),
	(GTTX_Text), (ULONG)"00:00:01", (TAG_DONE)
};

ULONG TraceLabelGTags[] = {
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE),
	(GTST_MaxChars), 10, (STRINGA_Justification), (GACT_STRINGCENTER), (TAG_DONE)
};

ULONG PaletteGTags[] = {
	(GTPA_Depth), 3, (GTPA_Color), 1, (GTPA_ColorOffset), 0, (TAG_DONE),
	(GTSL_MaxLevelLen), 3, (GTSL_LevelFormat), (ULONG)"%ld", (GTSL_LevelPlace), (PLACETEXT_RIGHT), (PGA_Freedom), LORIENT_HORIZ, (GA_RelVerify), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GTSL_MaxLevelLen), 3, (GTSL_LevelFormat), (ULONG)"%ld", (GTSL_LevelPlace), (PLACETEXT_RIGHT), (PGA_Freedom), LORIENT_HORIZ, (GA_RelVerify), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GTSL_MaxLevelLen), 3, (GTSL_LevelFormat), (ULONG)"%ld", (GTSL_LevelPlace), (PLACETEXT_RIGHT), (PGA_Freedom), LORIENT_HORIZ, (GA_RelVerify), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE)
};

ULONG EditNameGTags[] = {
	(GTST_MaxChars), 4, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 12, (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&EN_PlaceG15Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&EN_ArcG15Labels[ 0 ], (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&EN_KindG15Labels[ 0 ], (TAG_DONE)
};

ULONG EditSinglePadGTags[] = {
	(GTST_MaxChars), 10, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 10, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 10, (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_TypeG16Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_LayerG16Labels[ 0 ], (GTCY_Active), 1, (GT_Underscore), '_', (TAG_DONE),
	(GTCB_Checked), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 4, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 8, (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_PlaceG16Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE),
	(GTCY_Labels), (ULONG)&EP_ArcG16Labels[ 0 ], (GT_Underscore), '_', (TAG_DONE)
};

UWORD ComputeX( UWORD value )
{
	return(( UWORD )((( FontX * value ) + 4 ) / 8 ));
}

UWORD ComputeY( UWORD value )
{
	return(( UWORD )((( FontY * value ) + 4 ) / 8 ));
}

static void ComputeFont( UWORD width, UWORD height )
{
	Font = &Attr;
	Font->ta_Name = (STRPTR)Scr->RastPort.Font->tf_Message.mn_Node.ln_Name;
	Font->ta_YSize = FontY = Scr->RastPort.Font->tf_YSize;
	FontX = Scr->RastPort.Font->tf_XSize;

	OffX = Scr->WBorLeft;
	OffY = Scr->RastPort.TxHeight + Scr->WBorTop + 1;

	if ( width && height ) {
		if (( ComputeX( width ) + OffX + Scr->WBorRight ) > Scr->Width )
			goto UseTopaz;
		if (( ComputeY( height ) + OffY + Scr->WBorBottom ) > Scr->Height )
			goto UseTopaz;
	}
	return;

UseTopaz:
	Font->ta_Name = (STRPTR)"topaz.font";
	FontX = FontY = Font->ta_YSize = 8;
}

int SetupScreen( void )
{
	if ( ! ( Scr = LockPubScreen( PubScreenName )))
		return( 1L );

	ComputeFont( 0, 0 );

	if ( ! ( VisualInfo = GetVisualInfo( Scr, TAG_DONE )))
		return( 2L );

	return( 0L );
}

void CloseDownScreen( void )
{
	if ( VisualInfo ) {
		FreeVisualInfo( VisualInfo );
		VisualInfo = NULL;
	}

	if ( Scr	) {
		UnlockPubScreen( NULL, Scr );
		Scr = NULL;
	}
}

void PlotRender( void )
{
	ComputeFont( PlotWidth, PlotHeight );

	DrawBevelBox( PlotWnd->RPort, OffX + ComputeX( 13 ),
					OffY + ComputeY( 6 ),
					ComputeX( 283 ),
					ComputeY( 96 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenPlotWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = PlotLeft, wtop = PlotTop, ww, wh;

	ComputeFont( PlotWidth, PlotHeight );

	ww = ComputeX( PlotWidth );
	wh = ComputeY( PlotHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &PlotGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Plot_CNT; lc++ ) {

		CopyMem((char * )&PlotNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		PlotGadgets[ lc ] = g = CreateGadgetA((ULONG)PlotGTypes[ lc ], g, &ng, ( struct TagItem * )&PlotGTags[ tc ] );

		while( PlotGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( PlotWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	BUTTONIDCMP|CHECKBOXIDCMP|STRINGIDCMP|CYCLEIDCMP|IDCMP_GADGETDOWN|IDCMP_MENUPICK|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	PlotGList,
				WA_Title,	PlotWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( PlotWnd, NULL );

	PlotRender();

	return( 0L );
}

void ClosePlotWindow( void )
{
	if ( PlotMenus	    ) {
		ClearMenuStrip( PlotWnd );
		FreeMenus( PlotMenus );
		PlotMenus = NULL;	}

	if ( PlotWnd	    ) {
		CloseWindow( PlotWnd );
		PlotWnd = NULL;
	}

	if ( PlotGList	    ) {
		FreeGadgets( PlotGList );
		PlotGList = NULL;
	}
}

void PrintXRender( void )
{
	struct IntuiText	it;
	UWORD			cnt;

	ComputeFont( PrintXWidth, PrintXHeight );

	DrawBevelBox( PrintXWnd->RPort, OffX + ComputeX( 6 ),
					OffY + ComputeY( 2 ),
					ComputeX( 288 ),
					ComputeY( 31 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
	DrawBevelBox( PrintXWnd->RPort, OffX + ComputeX( 6 ),
					OffY + ComputeY( 116 ),
					ComputeX( 288 ),
					ComputeY( 36 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
	DrawBevelBox( PrintXWnd->RPort, OffX + ComputeX( 6 ),
					OffY + ComputeY( 35 ),
					ComputeX( 289 ),
					ComputeY( 79 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );

	for ( cnt = 0; cnt < PrintX_TNUM; cnt++ ) {
		CopyMem(( char * )&PrintXIText[ cnt ], ( char * )&it, (long)sizeof( struct IntuiText ));
		it.ITextFont = Font;
		it.LeftEdge  = OffX + ComputeX( it.LeftEdge ) - ( IntuiTextLength( &it ) >> 1 );
		it.TopEdge   = OffY + ComputeY( it.TopEdge ) - ( Font->ta_YSize >> 1 );
		PrintIText( PrintXWnd->RPort, &it, 0, 0 );
	}
}

int OpenPrintXWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = PrintXLeft, wtop = PrintXTop, ww, wh;

	ComputeFont( PrintXWidth, PrintXHeight );

	ww = ComputeX( PrintXWidth );
	wh = ComputeY( PrintXHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &PrintXGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < PrintX_CNT; lc++ ) {

		CopyMem((char * )&PrintXNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		PrintXGadgets[ lc ] = g = CreateGadgetA((ULONG)PrintXGTypes[ lc ], g, &ng, ( struct TagItem * )&PrintXGTags[ tc ] );

		while( PrintXGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( PrintXWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	CHECKBOXIDCMP|BUTTONIDCMP|CYCLEIDCMP|STRINGIDCMP|INTEGERIDCMP|SLIDERIDCMP|TEXTIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	PrintXGList,
				WA_Title,	PrintXWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( PrintXWnd, NULL );

	PrintXRender();

	return( 0L );
}

void ClosePrintXWindow( void )
{
	if ( PrintXWnd	      ) {
		CloseWindow( PrintXWnd );
		PrintXWnd = NULL;
	}

	if ( PrintXGList      ) {
		FreeGadgets( PrintXGList );
		PrintXGList = NULL;
	}
}

void GetPartRender( void )
{
	ComputeFont( GetPartWidth, GetPartHeight );

	DrawBevelBox( GetPartWnd->RPort, OffX + ComputeX( 13 ),
					OffY + ComputeY( 5 ),
					ComputeX( 217 ),
					ComputeY( 99 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenGetPartWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = GetPartLeft, wtop = GetPartTop, ww, wh;

	ComputeFont( GetPartWidth, GetPartHeight );

	ww = ComputeX( GetPartWidth );
	wh = ComputeY( GetPartHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &GetPartGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < GetPart_CNT; lc++ ) {

		CopyMem((char * )&GetPartNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		GetPartGadgets[ lc ] = g = CreateGadgetA((ULONG)GetPartGTypes[ lc ], g, &ng, ( struct TagItem * )&GetPartGTags[ tc ] );

		while( GetPartGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( GetPartWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	CHECKBOXIDCMP|BUTTONIDCMP|IDCMP_GADGETDOWN|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	GetPartGList,
				WA_Title,	GetPartWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( GetPartWnd, NULL );

	GetPartRender();

	return( 0L );
}

void CloseGetPartWindow( void )
{
	if ( GetPartWnd        ) {
		CloseWindow( GetPartWnd );
		GetPartWnd = NULL;
	}

	if ( GetPartGList      ) {
		FreeGadgets( GetPartGList );
		GetPartGList = NULL;
	}
}

void BoardPrefRender( void )
{
	ComputeFont( BoardPrefWidth, BoardPrefHeight );

	DrawBevelBox( BoardPrefWnd->RPort, OffX + ComputeX( 4 ),
					OffY + ComputeY( 3 ),
					ComputeX( 324 ),
					ComputeY( 143 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenBoardPrefWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = BoardPrefLeft, wtop = BoardPrefTop, ww, wh;

	ComputeFont( BoardPrefWidth, BoardPrefHeight );

	ww = ComputeX( BoardPrefWidth );
	wh = ComputeY( BoardPrefHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &BoardPrefGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < BoardPref_CNT; lc++ ) {

		CopyMem((char * )&BoardPrefNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		BoardPrefGadgets[ lc ] = g = CreateGadgetA((ULONG)BoardPrefGTypes[ lc ], g, &ng, ( struct TagItem * )&BoardPrefGTags[ tc ] );

		while( BoardPrefGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( BoardPrefWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	STRINGIDCMP|BUTTONIDCMP|CHECKBOXIDCMP|CYCLEIDCMP|IDCMP_GADGETDOWN|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	BoardPrefGList,
				WA_Title,	BoardPrefWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( BoardPrefWnd, NULL );

	BoardPrefRender();

	return( 0L );
}

void CloseBoardPrefWindow( void )
{
	if ( BoardPrefWnd	 ) {
		CloseWindow( BoardPrefWnd );
		BoardPrefWnd = NULL;
	}

	if ( BoardPrefGList	 ) {
		FreeGadgets( BoardPrefGList );
		BoardPrefGList = NULL;
	}
}

void MiscRender( void )
{
	ComputeFont( MiscWidth, MiscHeight );

	DrawBevelBox( MiscWnd->RPort, OffX + ComputeX( 11 ),
					OffY + ComputeY( 3 ),
					ComputeX( 242 ),
					ComputeY( 157 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenMiscWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = MiscLeft, wtop = MiscTop, ww, wh;

	ComputeFont( MiscWidth, MiscHeight );

	ww = ComputeX( MiscWidth );
	wh = ComputeY( MiscHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &MiscGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Misc_CNT; lc++ ) {

		CopyMem((char * )&MiscNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		MiscGadgets[ lc ] = g = CreateGadgetA((ULONG)MiscGTypes[ lc ], g, &ng, ( struct TagItem * )&MiscGTags[ tc ] );

		while( MiscGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( MiscWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	BUTTONIDCMP|INTEGERIDCMP|CYCLEIDCMP|STRINGIDCMP|TEXTIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	MiscGList,
				WA_Title,	MiscWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( MiscWnd, NULL );

	MiscRender();

	return( 0L );
}

void CloseMiscWindow( void )
{
	if ( MiscWnd	    ) {
		CloseWindow( MiscWnd );
		MiscWnd = NULL;
	}

	if ( MiscGList	    ) {
		FreeGadgets( MiscGList );
		MiscGList = NULL;
	}
}

void EditPadsRender( void )
{
	struct IntuiText	it;
	UWORD			cnt;

	ComputeFont( EditPadsWidth, EditPadsHeight );

	DrawBevelBox( EditPadsWnd->RPort, OffX + ComputeX( 7 ),
					OffY + ComputeY( 2 ),
					ComputeX( 389 ),
					ComputeY( 167 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );

	for ( cnt = 0; cnt < EditPads_TNUM; cnt++ ) {
		CopyMem(( char * )&EditPadsIText[ cnt ], ( char * )&it, (long)sizeof( struct IntuiText ));
		it.ITextFont = Font;
		it.LeftEdge  = OffX + ComputeX( it.LeftEdge ) - ( IntuiTextLength( &it ) >> 1 );
		it.TopEdge   = OffY + ComputeY( it.TopEdge ) - ( Font->ta_YSize >> 1 );
		PrintIText( EditPadsWnd->RPort, &it, 0, 0 );
	}
}

int OpenEditPadsWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = EditPadsLeft, wtop = EditPadsTop, ww, wh;

	ComputeFont( EditPadsWidth, EditPadsHeight );

	ww = ComputeX( EditPadsWidth );
	wh = ComputeY( EditPadsHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &EditPadsGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < EditPads_CNT; lc++ ) {

		CopyMem((char * )&EditPadsNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		EditPadsGadgets[ lc ] = g = CreateGadgetA((ULONG)EditPadsGTypes[ lc ], g, &ng, ( struct TagItem * )&EditPadsGTags[ tc ] );

		while( EditPadsGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( EditPadsWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	STRINGIDCMP|CYCLEIDCMP|CHECKBOXIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_SMART_REFRESH,
				WA_Gadgets,	EditPadsGList,
				WA_Title,	EditPadsWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( EditPadsWnd, NULL );

	EditPadsRender();

	return( 0L );
}

void CloseEditPadsWindow( void )
{
	if ( EditPadsWnd	) {
		CloseWindow( EditPadsWnd );
		EditPadsWnd = NULL;
	}

	if ( EditPadsGList	) {
		FreeGadgets( EditPadsGList );
		EditPadsGList = NULL;
	}
}

void Step_mmRender( void )
{
	ComputeFont( Step_mmWidth, Step_mmHeight );

	DrawBevelBox( Step_mmWnd->RPort, OffX + ComputeX( 6 ),
					OffY + ComputeY( 5 ),
					ComputeX( 213 ),
					ComputeY( 38 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenStep_mmWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = Step_mmLeft, wtop = Step_mmTop, ww, wh;

	ComputeFont( Step_mmWidth, Step_mmHeight );

	ww = ComputeX( Step_mmWidth );
	wh = ComputeY( Step_mmHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &Step_mmGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Step_mm_CNT; lc++ ) {

		CopyMem((char * )&Step_mmNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		Step_mmGadgets[ lc ] = g = CreateGadgetA((ULONG)Step_mmGTypes[ lc ], g, &ng, ( struct TagItem * )&Step_mmGTags[ tc ] );

		while( Step_mmGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( Step_mmWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	CYCLEIDCMP|STRINGIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	Step_mmGList,
				WA_Title,	Step_mmWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( Step_mmWnd, NULL );

	Step_mmRender();

	return( 0L );
}

void CloseStep_mmWindow( void )
{
	if ( Step_mmWnd        ) {
		CloseWindow( Step_mmWnd );
		Step_mmWnd = NULL;
	}

	if ( Step_mmGList      ) {
		FreeGadgets( Step_mmGList );
		Step_mmGList = NULL;
	}
}

void Grid_mmRender( void )
{
	ComputeFont( Grid_mmWidth, Grid_mmHeight );

	DrawBevelBox( Grid_mmWnd->RPort, OffX + ComputeX( 6 ),
					OffY + ComputeY( 5 ),
					ComputeX( 209 ),
					ComputeY( 51 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenGrid_mmWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = Grid_mmLeft, wtop = Grid_mmTop, ww, wh;

	ComputeFont( Grid_mmWidth, Grid_mmHeight );

	ww = ComputeX( Grid_mmWidth );
	wh = ComputeY( Grid_mmHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &Grid_mmGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Grid_mm_CNT; lc++ ) {

		CopyMem((char * )&Grid_mmNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		Grid_mmGadgets[ lc ] = g = CreateGadgetA((ULONG)Grid_mmGTypes[ lc ], g, &ng, ( struct TagItem * )&Grid_mmGTags[ tc ] );

		while( Grid_mmGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( Grid_mmWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	CYCLEIDCMP|STRINGIDCMP|BUTTONIDCMP|CHECKBOXIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	Grid_mmGList,
				WA_Title,	Grid_mmWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( Grid_mmWnd, NULL );

	Grid_mmRender();

	return( 0L );
}

void CloseGrid_mmWindow( void )
{
	if ( Grid_mmWnd        ) {
		CloseWindow( Grid_mmWnd );
		Grid_mmWnd = NULL;
	}

	if ( Grid_mmGList      ) {
		FreeGadgets( Grid_mmGList );
		Grid_mmGList = NULL;
	}
}

void PrintingRender( void )
{
	struct IntuiText	it;
	UWORD			cnt;

	ComputeFont( PrintingWidth, PrintingHeight );


	for ( cnt = 0; cnt < Printing_TNUM; cnt++ ) {
		CopyMem(( char * )&PrintingIText[ cnt ], ( char * )&it, (long)sizeof( struct IntuiText ));
		it.ITextFont = Font;
		it.LeftEdge  = OffX + ComputeX( it.LeftEdge ) - ( IntuiTextLength( &it ) >> 1 );
		it.TopEdge   = OffY + ComputeY( it.TopEdge ) - ( Font->ta_YSize >> 1 );
		PrintIText( PrintingWnd->RPort, &it, 0, 0 );
	}
}

int OpenPrintingWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = PrintingLeft, wtop = PrintingTop, ww, wh;

	ComputeFont( PrintingWidth, PrintingHeight );

	ww = ComputeX( PrintingWidth );
	wh = ComputeY( PrintingHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &PrintingGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Printing_CNT; lc++ ) {

		CopyMem((char * )&PrintingNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		PrintingGadgets[ lc ] = g = CreateGadgetA((ULONG)PrintingGTypes[ lc ], g, &ng, ( struct TagItem * )&PrintingGTags[ tc ] );

		while( PrintingGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( PrintingWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	PrintingGList,
				WA_Title,	PrintingWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( PrintingWnd, NULL );

	PrintingRender();

	return( 0L );
}

void ClosePrintingWindow( void )
{
	if ( PrintingWnd	) {
		CloseWindow( PrintingWnd );
		PrintingWnd = NULL;
	}

	if ( PrintingGList	) {
		FreeGadgets( PrintingGList );
		PrintingGList = NULL;
	}
}

void PartsLibRender( void )
{
	ComputeFont( PartsLibWidth, PartsLibHeight );

	DrawBevelBox( PartsLibWnd->RPort, OffX + ComputeX( 5 ),
					OffY + ComputeY( 3 ),
					ComputeX( 337 ),
					ComputeY( 177 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenPartsLibWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = PartsLibLeft, wtop = PartsLibTop, ww, wh;

	ComputeFont( PartsLibWidth, PartsLibHeight );

	ww = ComputeX( PartsLibWidth );
	wh = ComputeY( PartsLibHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &PartsLibGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < PartsLib_CNT; lc++ ) {

		CopyMem((char * )&PartsLibNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		PartsLibGadgets[ lc ] = g = CreateGadgetA((ULONG)PartsLibGTypes[ lc ], g, &ng, ( struct TagItem * )&PartsLibGTags[ tc ] );

		while( PartsLibGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( PartsLibWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	LISTVIEWIDCMP|STRINGIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	PartsLibGList,
				WA_Title,	PartsLibWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( PartsLibWnd, NULL );

	PartsLibRender();

	return( 0L );
}

void ClosePartsLibWindow( void )
{
	if ( PartsLibWnd	) {
		CloseWindow( PartsLibWnd );
		PartsLibWnd = NULL;
	}

	if ( PartsLibGList	) {
		FreeGadgets( PartsLibGList );
		PartsLibGList = NULL;
	}
}

void BuildPageRender( void )
{
	struct IntuiText	it;
	UWORD			cnt;

	ComputeFont( BuildPageWidth, BuildPageHeight );


	for ( cnt = 0; cnt < BuildPage_TNUM; cnt++ ) {
		CopyMem(( char * )&BuildPageIText[ cnt ], ( char * )&it, (long)sizeof( struct IntuiText ));
		it.ITextFont = Font;
		it.LeftEdge  = OffX + ComputeX( it.LeftEdge ) - ( IntuiTextLength( &it ) >> 1 );
		it.TopEdge   = OffY + ComputeY( it.TopEdge ) - ( Font->ta_YSize >> 1 );
		PrintIText( BuildPageWnd->RPort, &it, 0, 0 );
	}
}

int OpenBuildPageWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = BuildPageLeft, wtop = BuildPageTop, ww, wh;

	ComputeFont( BuildPageWidth, BuildPageHeight );

	ww = ComputeX( BuildPageWidth );
	wh = ComputeY( BuildPageHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &BuildPageGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < BuildPage_CNT; lc++ ) {

		CopyMem((char * )&BuildPageNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		BuildPageGadgets[ lc ] = g = CreateGadgetA((ULONG)BuildPageGTypes[ lc ], g, &ng, ( struct TagItem * )&BuildPageGTags[ tc ] );

		while( BuildPageGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( BuildPageWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	TEXTIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	BuildPageGList,
				WA_Title,	BuildPageWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( BuildPageWnd, NULL );

	BuildPageRender();

	return( 0L );
}

void CloseBuildPageWindow( void )
{
	if ( BuildPageWnd	 ) {
		CloseWindow( BuildPageWnd );
		BuildPageWnd = NULL;
	}

	if ( BuildPageGList	 ) {
		FreeGadgets( BuildPageGList );
		BuildPageGList = NULL;
	}
}

void SpecialRender( void )
{
	struct IntuiText	it;
	UWORD			cnt;

	ComputeFont( SpecialWidth, SpecialHeight );

	DrawBevelBox( SpecialWnd->RPort, OffX + ComputeX( 7 ),
					OffY + ComputeY( 3 ),
					ComputeX( 240 ),
					ComputeY( 77 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );

	for ( cnt = 0; cnt < Special_TNUM; cnt++ ) {
		CopyMem(( char * )&SpecialIText[ cnt ], ( char * )&it, (long)sizeof( struct IntuiText ));
		it.ITextFont = Font;
		it.LeftEdge  = OffX + ComputeX( it.LeftEdge ) - ( IntuiTextLength( &it ) >> 1 );
		it.TopEdge   = OffY + ComputeY( it.TopEdge ) - ( Font->ta_YSize >> 1 );
		PrintIText( SpecialWnd->RPort, &it, 0, 0 );
	}
}

int OpenSpecialWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = SpecialLeft, wtop = SpecialTop, ww, wh;

	ComputeFont( SpecialWidth, SpecialHeight );

	ww = ComputeX( SpecialWidth );
	wh = ComputeY( SpecialHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &SpecialGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Special_CNT; lc++ ) {

		CopyMem((char * )&SpecialNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		SpecialGadgets[ lc ] = g = CreateGadgetA((ULONG)SpecialGTypes[ lc ], g, &ng, ( struct TagItem * )&SpecialGTags[ tc ] );

		while( SpecialGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( SpecialWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	CHECKBOXIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	SpecialGList,
				WA_Title,	SpecialWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( SpecialWnd, NULL );

	SpecialRender();

	return( 0L );
}

void CloseSpecialWindow( void )
{
	if ( SpecialWnd        ) {
		CloseWindow( SpecialWnd );
		SpecialWnd = NULL;
	}

	if ( SpecialGList      ) {
		FreeGadgets( SpecialGList );
		SpecialGList = NULL;
	}
}

void AboutRender( void )
{
	struct IntuiText	it;
	UWORD			cnt;

	ComputeFont( AboutWidth, AboutHeight );

	DrawBevelBox( AboutWnd->RPort, OffX + ComputeX( 12 ),
					OffY + ComputeY( 5 ),
					ComputeX( 426 ),
					ComputeY( 143 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );

	for ( cnt = 0; cnt < About_TNUM; cnt++ ) {
		CopyMem(( char * )&AboutIText[ cnt ], ( char * )&it, (long)sizeof( struct IntuiText ));
		it.ITextFont = Font;
		it.LeftEdge  = OffX + ComputeX( it.LeftEdge ) - ( IntuiTextLength( &it ) >> 1 );
		it.TopEdge   = OffY + ComputeY( it.TopEdge ) - ( Font->ta_YSize >> 1 );
		PrintIText( AboutWnd->RPort, &it, 0, 0 );
	}
}

int OpenAboutWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = AboutLeft, wtop = AboutTop, ww, wh;

	ComputeFont( AboutWidth, AboutHeight );

	ww = ComputeX( AboutWidth );
	wh = ComputeY( AboutHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &AboutGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < About_CNT; lc++ ) {

		CopyMem((char * )&AboutNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		AboutGadgets[ lc ] = g = CreateGadgetA((ULONG)AboutGTypes[ lc ], g, &ng, ( struct TagItem * )&AboutGTags[ tc ] );

		while( AboutGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( AboutWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	BUTTONIDCMP|TEXTIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	AboutGList,
				WA_Title,	AboutWdt,
				WA_PubScreen,	Scr,
				WA_AutoAdjust,	TRUE,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( AboutWnd, NULL );

	AboutRender();

	return( 0L );
}

void CloseAboutWindow( void )
{
	if ( AboutWnd	     ) {
		CloseWindow( AboutWnd );
		AboutWnd = NULL;
	}

	if ( AboutGList      ) {
		FreeGadgets( AboutGList );
		AboutGList = NULL;
	}
}

void TraceLabelRender( void )
{
	struct IntuiText	it;
	UWORD			cnt;

	ComputeFont( TraceLabelWidth, TraceLabelHeight );

	DrawBevelBox( TraceLabelWnd->RPort, OffX + ComputeX( 8 ),
					OffY + ComputeY( 3 ),
					ComputeX( 269 ),
					ComputeY( 144 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );

	for ( cnt = 0; cnt < TraceLabel_TNUM; cnt++ ) {
		CopyMem(( char * )&TraceLabelIText[ cnt ], ( char * )&it, (long)sizeof( struct IntuiText ));
		it.ITextFont = Font;
		it.LeftEdge  = OffX + ComputeX( it.LeftEdge ) - ( IntuiTextLength( &it ) >> 1 );
		it.TopEdge   = OffY + ComputeY( it.TopEdge ) - ( Font->ta_YSize >> 1 );
		PrintIText( TraceLabelWnd->RPort, &it, 0, 0 );
	}
}

int OpenTraceLabelWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = TraceLabelLeft, wtop = TraceLabelTop, ww, wh;

	ComputeFont( TraceLabelWidth, TraceLabelHeight );

	ww = ComputeX( TraceLabelWidth );
	wh = ComputeY( TraceLabelHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &TraceLabelGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < TraceLabel_CNT; lc++ ) {

		CopyMem((char * )&TraceLabelNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		TraceLabelGadgets[ lc ] = g = CreateGadgetA((ULONG)TraceLabelGTypes[ lc ], g, &ng, ( struct TagItem * )&TraceLabelGTags[ tc ] );

		while( TraceLabelGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( TraceLabelWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	STRINGIDCMP|BUTTONIDCMP|IDCMP_GADGETDOWN|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	TraceLabelGList,
				WA_Title,	TraceLabelWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( TraceLabelWnd, NULL );

	TraceLabelRender();

	return( 0L );
}

void CloseTraceLabelWindow( void )
{
	if ( TraceLabelWnd	  ) {
		CloseWindow( TraceLabelWnd );
		TraceLabelWnd = NULL;
	}

	if ( TraceLabelGList	  ) {
		FreeGadgets( TraceLabelGList );
		TraceLabelGList = NULL;
	}
}

void PaletteRender( void )
{
	ComputeFont( PaletteWidth, PaletteHeight );

	DrawBevelBox( PaletteWnd->RPort, OffX + ComputeX( 23 ),
					OffY + ComputeY( 8 ),
					ComputeX( 60 ),
					ComputeY( 23 ),
					GT_VisualInfo, VisualInfo, TAG_DONE );
	DrawBevelBox( PaletteWnd->RPort, OffX + ComputeX( 11 ),
					OffY + ComputeY( 4 ),
					ComputeX( 358 ),
					ComputeY( 67 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenPaletteWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = PaletteLeft, wtop = PaletteTop, ww, wh;

	ComputeFont( PaletteWidth, PaletteHeight );

	ww = ComputeX( PaletteWidth );
	wh = ComputeY( PaletteHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &PaletteGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Palette_CNT; lc++ ) {

		CopyMem((char * )&PaletteNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		PaletteGadgets[ lc ] = g = CreateGadgetA((ULONG)PaletteGTypes[ lc ], g, &ng, ( struct TagItem * )&PaletteGTags[ tc ] );

		while( PaletteGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( PaletteWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	PALETTEIDCMP|SLIDERIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	PaletteGList,
				WA_Title,	PaletteWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( PaletteWnd, NULL );

	PaletteRender();

	return( 0L );
}

void ClosePaletteWindow( void )
{
	if ( PaletteWnd        ) {
		CloseWindow( PaletteWnd );
		PaletteWnd = NULL;
	}

	if ( PaletteGList      ) {
		FreeGadgets( PaletteGList );
		PaletteGList = NULL;
	}
}

void EditNameRender( void )
{
	ComputeFont( EditNameWidth, EditNameHeight );

	DrawBevelBox( EditNameWnd->RPort, OffX + ComputeX( 11 ),
					OffY + ComputeY( 4 ),
					ComputeX( 336 ),
					ComputeY( 39 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenEditNameWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = EditNameLeft, wtop = EditNameTop, ww, wh;

	ComputeFont( EditNameWidth, EditNameHeight );

	ww = ComputeX( EditNameWidth );
	wh = ComputeY( EditNameHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &EditNameGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < EditName_CNT; lc++ ) {

		CopyMem((char * )&EditNameNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		EditNameGadgets[ lc ] = g = CreateGadgetA((ULONG)EditNameGTypes[ lc ], g, &ng, ( struct TagItem * )&EditNameGTags[ tc ] );

		while( EditNameGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( EditNameWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	STRINGIDCMP|CYCLEIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	EditNameGList,
				WA_Title,	EditNameWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( EditNameWnd, NULL );

	EditNameRender();

	return( 0L );
}

void CloseEditNameWindow( void )
{
	if ( EditNameWnd	) {
		CloseWindow( EditNameWnd );
		EditNameWnd = NULL;
	}

	if ( EditNameGList	) {
		FreeGadgets( EditNameGList );
		EditNameGList = NULL;
	}
}

void EditSinglePadRender( void )
{
	ComputeFont( EditSinglePadWidth, EditSinglePadHeight );

	DrawBevelBox( EditSinglePadWnd->RPort, OffX + ComputeX( 10 ),
					OffY + ComputeY( 4 ),
					ComputeX( 357 ),
					ComputeY( 88 ),
					GT_VisualInfo, VisualInfo, GTBB_Recessed, TRUE, TAG_DONE );
}

int OpenEditSinglePadWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = EditSinglePadLeft, wtop = EditSinglePadTop, ww, wh;

	ComputeFont( EditSinglePadWidth, EditSinglePadHeight );

	ww = ComputeX( EditSinglePadWidth );
	wh = ComputeY( EditSinglePadHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( g = CreateContext( &EditSinglePadGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < EditSinglePad_CNT; lc++ ) {

		CopyMem((char * )&EditSinglePadNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr	 = Font;
		ng.ng_LeftEdge	 = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge	 = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width	 = ComputeX( ng.ng_Width );
		ng.ng_Height	 = ComputeY( ng.ng_Height);

		EditSinglePadGadgets[ lc ] = g = CreateGadgetA((ULONG)EditSinglePadGTypes[ lc ], g, &ng, ( struct TagItem * )&EditSinglePadGTags[ tc ] );

		while( EditSinglePadGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( EditSinglePadWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top, 	wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	STRINGIDCMP|CYCLEIDCMP|CHECKBOXIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_SMART_REFRESH,
				WA_Gadgets,	EditSinglePadGList,
				WA_Title,	EditSinglePadWdt,
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( EditSinglePadWnd, NULL );

	EditSinglePadRender();

	return( 0L );
}

void CloseEditSinglePadWindow( void )
{
	if ( EditSinglePadWnd	     ) {
		CloseWindow( EditSinglePadWnd );
		EditSinglePadWnd = NULL;
	}

	if ( EditSinglePadGList      ) {
		FreeGadgets( EditSinglePadGList );
		EditSinglePadGList = NULL;
	}
}
