/*************************************************************************
 *
 * PROGRAM	    CrazyPads
 * PART 	    main.c
 * VERSION	    0.70
 * DATE 	    1990-09-01
 * CHANGED	    1994-06-07
 * AUTHOR	    Klaus Rotter
 * E-MAIL	    klaus@rotters.de
 * COMPUTER	    Amiga with (at least) Kickstart 2.04
 * EXTENSION
 * LANGUAGE	    ANSI-C
 * COMPILER	    DICE 2.07.56r
 * COPYRIGHT	GPL
 * COMMENT	    Needs reqtools.library V38 or higher
 *
 * (c) Copyright 1990-94 by Klaus Rotter. All rights reserved.
 * EMail: klaus@rotters.de
 *
 * Use it at your own risk. The program and the source code may be 
 * distributed under the terms of the GNU Public Licence (GPL).
 * For more informations read CrazyPads.doc.
 * Use it at your own risk.
 *
 ********************************************************************/

#include "defs.h"
#include "debug.h"
#include "/obj/prog-protos.h"

Prototype void HideIt(void);
Prototype void ShowIt(void);
Prototype void CleanUp(void);

Prototype void Ende(short ErrCode);
Prototype void DoWinActivate(void);
Prototype void EmptyMsgPort(void);
Prototype void DrawXY(short x,short y);
Prototype void GetKoords(void);
Prototype void DoGrid(void);
Prototype void UpdateUndo(void);
Prototype void RefreshRegion(short xs, short ys, short xe, short ye, short cls);
Prototype void DoRefresh(void);
Prototype short FileRequest(char *Hail);
Prototype short LoadIt(void);
Prototype short SaveIt(void);
Prototype void SetStdColor(void);
Prototype void SetReqColor(void);
Prototype void OpenAll(void);
Prototype void InstallAll(void);
Prototype void main(int argc, char *argv[]);
Prototype void MemoryDump(void);

Prototype void CloseAlScreen(void);
Prototype short OpenAlScreen(short width, short height, short oscan, short depth, long mode);
Prototype void OpenScrErr(short err);

Prototype struct  Pad		  *PCBStart, *PCBEnd, *PCBMax, *UndoBuffer, *UndoEnd;
Prototype struct  Screen	  *MyScreen;
Prototype struct  Window	  *DrawWin, *StatusWin, *DockWin;
Prototype struct  IntuiMessage	  *Message;
Prototype struct  IntuitionBase   *IntuitionBase;
Prototype struct  GfxBase	  *GfxBase;
Prototype struct  ReqToolsBase	  *ReqToolsBase;
Prototype struct  RastPort	  *RP, *RPs, *RPd;
Prototype struct  ViewPort	  *ViewPort;
Prototype struct  LayersBase	  *LayersBase;
Prototype struct  TmpRas	  Raster;
Prototype APTR	  OldErrorWindow;
Prototype struct  IntuiMessage	  MyMess;
Prototype ULONG   mtags[];

Prototype short   x, x1, x2, y, y1, y2, DrawKey;
Prototype short   DelFlag;
Prototype short   kx,ky;
Prototype short   Zoomfaktor;
Prototype short   MaxScreenX, MaxScreenY;
Prototype short   Tool;
Prototype short   PenColor;
Prototype short   PinSize;
Prototype short   TraceSize;
Prototype short   ComponentLayer;
Prototype short   SolderLayer;
Prototype short   LabelLayer;
Prototype short   PadLayer;
Prototype short   ActiveLayer, ExtSelFlag;
Prototype UBYTE   Toolstr[];
Prototype PLANEPTR BildSpeicher, BitPlane;
Prototype short   Zfak[];
Prototype char	  FRName[];
Prototype char	  AnswerArray[];
Prototype short   ActualdpiX, ActualdpiY;
Prototype short   PCBSizeX, PCBSizeY;
Prototype int	  DebugLevel;
Prototype short   ScrWidth, ScrHeight, ScrOScan, ScrDepth;
Prototype long	  ScrDId;
Prototype short  StatusHeight;
Prototype struct  TextAttr myfont8;
Prototype short   HideFlag, HideXYFlag;
Prototype short   ModCnt;
Prototype short   HideArea, ScrollStep;

Prototype short SelectCol, ClsCol, CompoLayerCol, CompoInactiveCol, SolderLayerCol;
Prototype short SolderInactiveCol, LabelLayerCol, LabelInactiveCol, GridCol, PadCol;
Prototype UBYTE SelectMask, SolderMask, CompoMask, LabelMask;
Prototype short ConnectCol, PartsCol;

struct	Screen		*MyScreen;
struct	Window		*DrawWin, *StatusWin, *DockWin;
struct	IntuiMessage	*Message;
struct	IntuitionBase	*IntuitionBase;
struct	GfxBase 	*GfxBase;
struct	ReqToolsBase	*ReqToolsBase;
struct	RastPort	*RP, *RPs, *RPd;
struct	ViewPort	*ViewPort;
struct	LayersBase	*LayersBase;
struct	TmpRas		Raster;
struct	IntuiMessage	MyMess;

struct	Menu		*CPMenus = NULL;

short	x, x1, x2, y, y1, y2, DrawKey;
short	DelFlag;
short	kx,ky;
short	MaxScreenX, MaxScreenY;
int	DebugLevel;
ULONG	Signals;

short	ModCnt = 0;

struct Pad *PCBStart, *PCBEnd, *PCBMax, *UndoBuffer, *UndoEnd;

/*
short	Zoomfaktor = 100;   // in Prozent: 100 = 1:1
short	BasedpiX = 256;     // Einheiten in 1/1600 inch
short	BasedpiY = 256;     //		"
*/
short	ActualdpiX = 256;   //		"
short	ActualdpiY = 256;   //		"
short	PCBSizeX = 10079;   //		"   // 160mm
short	PCBSizeY = 6300;    //		"   // 100mm
short	ScrollStep = 800;   //		"   // 1/2 in
short	TraceSize = 0;	    // Wird beim Startup eingestellt !

// Aktuelle Farbinformationen

// Die Farben 0=Dunkelgrau
//	      1=Schwarz
//	      2=Weiss
// sollten NIE veraendert werden !

// Einstellungen 8-Bit Farb-Bildschirm

short SelectCol = 6;
short ClsCol = 1;
short CompoLayerCol = 3;
short CompoInactiveCol = 0;
short SolderLayerCol = 5;
short SolderInactiveCol = 0;
short LabelLayerCol = 4;
short LabelInactiveCol = 4;
short GridCol = 2;
short ConnectCol = 6;
short PartsCol = 2;
short PadCol = 7;

UBYTE  SelectMask = 6;
UBYTE  SolderMask = 4;
UBYTE  CompoMask = 2;
UBYTE  LabelMask = 0xff;

short	Tool = ADD_PAD;
short	PenColor = 2;
short	PinSize = 1;

short	ComponentLayer;
short	SolderLayer;
short	LabelLayer;
short	PadLayer;

short	ActiveLayer, ExtSelFlag;

PLANEPTR BildSpeicher, BitPlane;

short Zfak[]={10,25,40,50,75,100,150,200,300,400,600,800,0};

struct TextAttr myfont8 = {
    (STRPTR)"topaz.font", 8, 0x00, 0x00 };

BPTR PrgStartLock = (BPTR) NULL;

ULONG mtags[] = {RT_ReqPos,REQPOS_CENTERSCR,RTEZ_Flags,EZREQF_CENTERTEXT,TAG_END};

APTR	OldErrorWindow;
short	pr_Flag = FALSE;

void Ende(short dummy)
{
#ifdef DEBUG
    if (DebugLevel > 0)
	printf("Enter Ende\n");
#endif
    CleanUp();
    CloseAlScreen();

    if (FontMem)	    free(FontMem);
    if (IntuitionBase)	CloseLibrary((struct Library *) IntuitionBase);
    if (GfxBase)	    CloseLibrary((struct Library *) GfxBase);
    if (ReqToolsBase)	CloseLibrary((struct Library *) ReqToolsBase);
    if (LayersBase)	    CloseLibrary(LayersBase);
    if (PCBStart)	    FreeMem(PCBStart, PCBMEM_SIZE);
    if (UndoBuffer)	    FreeMem(UndoBuffer, PCBMEM_SIZE);
    if (PartStart)	    FreeMem(PartStart, PARTMEM_SIZE);

    if (PrgStartLock)	UnLock(CurrentDir(PrgStartLock));

    exit(0);
}

short HideFlag = 0;
short HideXYFlag = 0;

void HideIt(void)
{
#ifdef DEBUG
    if (DebugLevel > 1)
	printf("Enter HideIt\n");
#endif
    if (HideFlag == 0)
    {
	SetDrMd(RP,JAM1|COMPLEMENT);
	WritePixel(RP,Zoll2X(kx),Zoll2Y(ky));

	switch (Tool)
	{
	    case ADD_PAD:
		DrawPad(x2,y2,PinSize,INVERS);
		break;

	    case ADD_TRACE:
		if (DrawKey)
		    Draw45Trace(INVERS);
		break;

	    case ADD_LINE:
		if (DrawKey)
		    DoLine(x1,y1,x2,y2,0,INVERS);
		break;

	    case ADD_ELLIPSE:
		if (DrawKey)
		    DoEllipse(x1,y1,x2,y2,0,INVERS);
		break;

	    case ADD_CIRCLE:
		break;

	    case ADD_RECT:
		if (DrawKey)
		    DoRect(x1,y1,x2,y2,0,INVERS);
		break;

	    case ADD_TEXT:
		DrawCursor(x1,y1);
		break;

	    case PART_CLEAR:
		if (DrawKey)
		    DoRect(x1,y1,x2,y2,0,INVERS);
		break;

	    case PART_COPY:
		if (DrawKey)
		    DoRect(x1,y1,x2,y2,0,INVERS);
		break;

	    case PART_ADD:
		HidePart();
		break;

	    default:
		HideFlag--;
	}
    }
    HideFlag++;

    if (PCBXYFLAG)
    {
	if (HideXYFlag == 0)
	    DrawXY(kx,ky);
	HideXYFlag++;
    }
}

void ShowIt(void)
{
#ifdef DEBUG
    if (DebugLevel > 0)
	printf("Enter ShowIt\n");
#endif
    if (HideFlag == 1)
    {
	SetDrMd(RP,JAM1|COMPLEMENT);
	WritePixel(RP,Zoll2X(kx),Zoll2Y(ky));

	switch (Tool)
	{
	    case ADD_PAD:
		DrawPad(x2,y2,PinSize,INVERS);
		break;

	    case ADD_TRACE:
		if (DrawKey)
		    Draw45Trace(INVERS);
		break;

	    case ADD_LINE:
		if (DrawKey)
		    DoLine(x1,y1,x2,y2,0,INVERS);
		break;

	    case ADD_ELLIPSE:
		if (DrawKey)
		    DoEllipse(x1,y1,x2,y2,0,INVERS);
		break;

	    case ADD_CIRCLE:
		break;

	    case ADD_RECT:
		if (DrawKey)
		    DoRect(x1,y1,x2,y2,0,INVERS);
		break;

	    case ADD_TEXT:
		DrawCursor(x1,y1);
		break;

	    case PART_CLEAR:
		if (DrawKey)
		    DoRect(x1,y1,x2,y2,0,INVERS);
		break;

	    case PART_COPY:
		if (DrawKey)
		    DoRect(x1,y1,x2,y2,0,INVERS);
		break;

	    case PART_ADD:
		InitPartAdd();
		break;

	    default:
		HideFlag++;
	}
    }
    if (HideFlag > 0) HideFlag--;

    if (PCBXYFLAG)
    {
	if (HideXYFlag == 1)
	    DrawXY(kx,ky);
	HideXYFlag--;
    }
}

void CleanUp(void)
{
    if (Tool == PART_ADD)
	CleanUpAddPart();

    DoOffXY();
    HideIt();
    DrawKey = 0;
    HideFlag = 0;
    EmptyMsgPort();

    if (SelectFlag)
	DrawEntry(SelectElement,SELECT);

    EmptyMsgPort();
}

short HideArea = FALSE;

void DoWinActivate(void)
{
    if (MyScreen->MouseY < StatusHeight)
    {
	if (IntuitionBase->ActiveWindow != StatusWin)
	{
	    if (IntuitionBase->ActiveWindow == DrawWin)
	    {
		HideIt();
		HideArea = TRUE;
	    }
	    ActivateWindow(StatusWin);
	    Message->Class = 0;
	}
    }
    else
    {
	if ((MyScreen->MouseX > MaxScreenX-DockSizeX) AND (MyScreen->MouseY < (DockWin->Height+DockWin->TopEdge)))
	{
	    if (IntuitionBase->ActiveWindow != DockWin)
	    {
		if (IntuitionBase->ActiveWindow == DrawWin)
		{
		    HideIt();
		    HideArea = TRUE;
		}
		ActivateWindow(DockWin);
		Message->Class = 0;
	    }
	}
	else
	{
	    if (IntuitionBase->ActiveWindow != DrawWin)
	    {
		ShowIt();
		ActivateWindow(DrawWin);
		HideArea = FALSE;
	    }
	}
    }
}

// EmptyMsgPort(): Leert den MessagePort

void EmptyMsgPort(void)
{
    while (Message = (struct IntuiMessage *) GetMsg(DrawWin->UserPort))
    {
	if (Message->Class == IDCMP_MOUSEMOVE)
	    DoWinActivate();
	ReplyMsg((struct Message *) Message);
    }

    while (Message = (struct IntuiMessage *) GetMsg(DockWin->UserPort))
    {
	if (Message->Class == IDCMP_MOUSEMOVE)
	    DoWinActivate();
	ReplyMsg((struct Message *) Message);
    }

    while (Message = (struct IntuiMessage *) GetMsg(StatusWin->UserPort))
    {
	CopyMem((APTR) Message, (APTR) &MyMess, sizeof(struct IntuiMessage));
	ReplyMsg((struct Message *) Message);
	Message = &MyMess;

	switch (Message->Class)
	{
	    case MENUPICK:
		SelectMenu();
		break;
	    case GADGETUP:
		SelectGadSt();
		break;
	    case IDCMP_MOUSEMOVE:
		DoWinActivate();
		break;
	}
    }
}

void DrawXY(short x,short y)
{
    SetDrMd(RP,JAM1|COMPLEMENT);
    x = Zoll2X(x);
    y = Zoll2Y(y);
    Move(RP,x,0);
    Draw(RP,x,MaxScreenY);
    Move(RP,0,y);
    Draw(RP,ScrLimXend,y);
}

void GetKoords(void)
{
    short StepHalf;
    long lx, ly;

    StepHalf = PCBSTEP/2;

    lx = (long) (Message->MouseX)*1600/ActualdpiX+PCBOFFSETX;
    ly = (long) (Message->MouseY-StatusHeight)*1600/ActualdpiY+PCBOFFSETY;

    if (lx > 32768)
	x = 32768;
    else if (lx < -32767)
	x = -32767;
    else
	x = lx;

    if (ly > 32768)
	y = 32768;
    else if (lx < -32767)
	y = -32767;
    else
	y = ly;

    if (x>0)
	x = ((x+StepHalf)/PCBSTEP)*PCBSTEP;
    else
	x = ((x-StepHalf)/PCBSTEP)*PCBSTEP;

    if (y>0)
	y = ((y+StepHalf)/PCBSTEP)*PCBSTEP;
    else
	y = ((y-StepHalf)/PCBSTEP)*PCBSTEP;
}

void DoGrid(void)
{
    short i,k, max_x, max_y, min_x, min_y;

    max_x = (long) (1600*ScrLimXend)/ActualdpiX + PCBOFFSETX + PCBGRID;
    max_y = (long) (1600*ScrLimXend)/ActualdpiY + PCBOFFSETY + PCBGRID;
    min_x = (PCBOFFSETX / PCBGRID) * PCBGRID;
    min_y = (PCBOFFSETY / PCBGRID) * PCBGRID;

    SetDrMd(RP,JAM1);
    SetAPen(RP,GridCol);
    for (i = min_x; i < max_x; i += PCBGRID)
    {
	for (k = min_y; k < max_y; k += PCBGRID)
	    WritePixel(RP,Zoll2X(i),Zoll2Y(k));
    }
}

void UpdateUndo(void)
{
    CopyMem((char *) PCBStart,(char *) UndoBuffer,(long) PCBEnd - (long) PCBStart + 1);
    (char *) UndoEnd = (char *) UndoBuffer + ((char *) PCBEnd - (char *) PCBStart);
}

void RefreshRegion(short xs, short ys, short xe, short ye, short cls)
{
    short xs_old, ys_old, xe_old, ye_old;

    HideIt();

    xs_old = ScrLimXstart;
    ys_old = ScrLimYstart;
    xe_old = ScrLimXend;
    ye_old = ScrLimYend;

    ScrLimXstart = xs;
    ScrLimYstart = ys;
    ScrLimXend	 = xe;
    ScrLimYend	 = ye;

    if (cls == TRUE)
    {
	SetAPen(RP,ClsCol);
	SetDrMd(RP,JAM1);
	RectFill(RP,xs,ys,xe,ye);
    }

    if (PCBGRIDFLAG)
	DoGrid();

    RefreshScreen();

    SetDrPt(RP,0x0f0f);
    SetAPen(RP,SelectCol);
    Move(RP,Zoll2X(0),Zoll2Y(0));
    Draw(RP,Zoll2X(PCBSizeX),Zoll2Y(0));
    Draw(RP,Zoll2X(PCBSizeX),Zoll2Y(PCBSizeY));
    Draw(RP,Zoll2X(0),Zoll2Y(PCBSizeY));
    Draw(RP,Zoll2X(0),Zoll2Y(0));
    SetDrPt(RP,0xFFFF);

    ScrLimXstart = xs_old;
    ScrLimYstart = ys_old;
    ScrLimXend	 = xe_old;
    ScrLimYend	 = ye_old;

    ShowIt();
}

void DoRefresh(void)
{
    HideIt();
    SetAPen(RP,ClsCol);  // Schwarz
    SetDrMd(RP,JAM1);
    RectFill(RP,0,StatusHeight,ScrLimXend,ScrLimYend);
    if (PCBGRIDFLAG)
	DoGrid();
    RefreshScreen();

    SetDrPt(RP,0x0f0f);
    SetAPen(RP,SelectCol);
    Move(RP,Zoll2X(0),Zoll2Y(0));
    Draw(RP,Zoll2X(PCBSizeX),Zoll2Y(0));
    Draw(RP,Zoll2X(PCBSizeX),Zoll2Y(PCBSizeY));
    Draw(RP,Zoll2X(0),Zoll2Y(PCBSizeY));
    Draw(RP,Zoll2X(0),Zoll2Y(0));
    SetDrPt(RP,0xFFFF);

    ShowIt();
}

void MemoryDump(void)
{
    printf("_PCBStart=$%0lx\n_PCBEnd=$%0lx\n_PCBMax=$%0lx\n",PCBStart,PCBEnd,PCBMax);
}

char	FRDir[108];
char	FRName[108];
char	AnswerArray[200];

short FileRequest(char *Hail)
{
    struct rtFileRequester *filereq;
    int dummy;

    ULONG tagsA[] = { RTFI_MatchPat, (ULONG) "#?.al",TAG_END };
    ULONG tagsF[] = { RT_ReqPos,REQPOS_CENTERSCR,TAG_END };

    if (filereq = rtAllocRequestA(RT_FILEREQ, NULL))
    {
	rtChangeReqAttrA(filereq,(struct TagItem *) tagsA);

	dummy = (int) rtFileRequestA(filereq,FRName,Hail,(struct TagItem *) tagsF);

	strcpy(AnswerArray,filereq->Dir);
	if (strlen(AnswerArray) > 0)
	    if (AnswerArray[strlen(AnswerArray)-1] != ':')
		strcat(AnswerArray,"/");

	strcat(AnswerArray,FRName);

	strcpy(FRDir,filereq->Dir);

	BPTR dummylock;

	if (dummylock = Lock(FRDir,ACCESS_READ))
	    UnLock(CurrentDir(dummylock));

	rtFreeRequest(filereq);
	return(dummy);
    }
    return (0);
}

/*
 *  Fileaufbau:  8 Bytes, (string) CRZYPDS+0
 *		 4 Bytes, (long)   Laenge
 *		 4 Bytes, (long)   Version
 */

char header[] = "CRZYPDS";

short LoadIt(void)
{
    int laenge;
    long MyFH;
    char buffer[13];		    /* 14 Char's */
    long Dummy;

    if (!(MyFH = Open(FRName,MODE_OLDFILE)))
	return(0);

    Read(MyFH,&buffer[0],8L);
    if (strcmp(&buffer[0],&header[0]) != 0)
    {
	rtEZRequest("\nThis file is not an CrazyPads data file\n","  OK  ",NULL,(struct TagItem *) mtags);
	return(1);
    }
    Read(MyFH,(char *) &Dummy,4L);
    if (Dummy > 9999)
    {
	rtEZRequest("\nTo modify this file you need\nCrazyPads V1.00 or higher\n","  OK  ",NULL,(struct TagItem *) mtags);
	return(1);
    }
    Read(MyFH,(char *) &Dummy,4L);
    laenge = Read(MyFH,(char *) PCBStart,Dummy);
    if (laenge != Dummy)
    {
	Close(MyFH);
	PCBEnd = PCBStart;
	return(0);
    }
    (char *) PCBEnd = (char *) PCBStart + (laenge-1L);
    Close(MyFH);
    ModCnt = 0;
    return(1);
}

short SaveIt(void)
{
    long MyFH;
    long Size;

    if (!(MyFH = Open(FRName,MODE_NEWFILE)))
	return(0);

    Write(MyFH,&header[0], 8L);
    Write(MyFH,(char *) &version, 4L);
    Size = (long) PCBEnd - (long) PCBStart+1;
    Write(MyFH,(char *) &Size,4L);
    if (!(Write(MyFH,(char *) PCBStart,(long) PCBEnd - (long) PCBStart + 1)))
    {
	Close(MyFH);
	return(0);
    }
    Close(MyFH);
    ModCnt = 0;
    return(1);
}

short print(char *string)
{
    Write(Output(),string,strlen(string));
    return(0);
}

void OpenAll(void)
{
    short err;

    struct Process *proc = (struct Process *) FindTask(NULL);

    PrgStartLock = CurrentDir(DupLock((BPTR)proc->pr_CurrentDir));

    if (!(IntuitionBase = (struct IntuitionBase *) OpenLibrary("intuition.library",37L)))
	Ende(print("ERROR: Kann intuition.library V37 nicht ffnen.\nCrazyPads bentigt OS 2.0\n"));

    if (!(GfxBase = (struct GfxBase *) OpenLibrary("graphics.library",37L)))
	Ende(print("ERROR: Kann graphics.library V37 nicht ffnen.\nCrazyPads bentigt OS 2.0\n"));

    if (!(ReqToolsBase = (struct ReqToolsBase *) OpenLibrary("reqtools.library",38L)))
	Ende(puts("ERROR: Kann reqtools.library V2.0 (V38) nicht ffnen."));

    if (!(LayersBase = (struct LayersBase *) OpenLibrary("layers.library",0L)))
	Ende(puts("ERROR: Kann layers.library nicht ffnen."));

    if (!(OpenDiskFont(&myfont8)))
	Ende(puts("ERROR: Kann topaz.font Groesse 8 nicht oeffnen"));

    if (!(PCBStart = (struct Pad *) AllocMem(PCBMEM_SIZE,MEMF_PUBLIC|MEMF_CLEAR)))
	Ende(puts("ERROR: Nicht genug Speicher frei (PCBStart)"));

    (char *) PCBMax = (char *) PCBStart + PCBMEM_SIZE;
    PCBEnd = PCBStart;

    if (!(UndoBuffer = (struct Pad *) AllocMem(PCBMEM_SIZE,MEMF_PUBLIC|MEMF_CLEAR)))
	Ende(puts("ERROR: Nicht genug Speicher frei (Buffer)"));

    if (!(PartStart = (struct Element *) AllocMem(PARTMEM_SIZE,MEMF_CLEAR)))
	Ende(puts("ERROR: Nicht genug Speicher frei (Part)"));

    (char *) PartMax = (char *) PartStart + PARTMEM_SIZE;
    PartEnd = PartStart;

    if (err = OpenAlScreen(STDSCREENWIDTH,STDSCREENHEIGHT,0,3,0x8004))
    {
	printf("ERROR: Unabel to open startup screen or window\n");
	printf("Maybe you ran out of Chip-RAM\n");
	switch (err)
	{
	    case 1: printf("Can't open Main-Screen\n");
		    break;
	    case 2: printf("Can't open Draw-Window\n");
		    break;
	    case 3: printf("Can't open Status-Window\n");
		    break;
	    case 4: printf("Can't alloc Bitplane\n");
		    break;
	    case 5: printf("Can't create menus\n");
	}
	Ende(0);
    }
    strcpy(FRName,"Unnamed");
}

void OpenScrErr(short err)
{
    char str[200];

    str[0] = 0;

    strcat(str,"\nUnable to use the desired screen mode\n\n");

    switch (err)
    {
	case 1: strcat(str,"Can't open Main-Screen\n\n");
		break;
	case 2: strcat(str,"Can't open Draw-Window\n\n");
		break;
	case 3: strcat(str,"Can't open Status-Window\n\n");
		break;
	case 4: strcat(str,"Can't alloc Bitplane\n\n");
		break;
	case 5: strcat(str,"Can't create menus\n\n");
    }
    strcat(str,"Should I quit or use the default screen mode ?\n");

    if (err == 1) // Kein Screen, also einen oeffnen
	OpenAlScreen(STDSCREENWIDTH,STDSCREENHEIGHT,0,2,0x8004);

    if (rtEZRequest(str," Quit | Default ",NULL,(struct TagItem *) mtags) == 1)
	Ende(0);
    else
    {
	CloseAlScreen();
	OpenAlScreen(STDSCREENWIDTH,STDSCREENHEIGHT,0,2,0x8004);
    }
}

struct Gadget StGad[11];
short  ScrWidth, ScrHeight, ScrOScan, ScrDepth;
long   ScrDId;

short  StatusHeight;

char PubName[] = "CrazyPads-PubScr";

short OpenAlScreen(short width, short height, short oscan, short depth, long mode)
{
    struct Process *MyProcess;
    UWORD pens[] = {-1,0};

#ifdef DEBUG
    if (DebugLevel > 0)
	printf("Enter OpenAlScreen\n");
#endif

    if (!(MyScreen = OpenScreenTags(NULL, SA_Width,  width,
					  SA_Height, height,
					  SA_Depth,  depth,
					  SA_Title,  "CrazyPads",
					  SA_Pens,   pens,
					  SA_Overscan, oscan,
					  SA_DisplayID, mode,
					  SA_Type,   CUSTOMSCREEN,
					  SA_Font,   &myfont8,
					  SA_PubName, PubName,
					  TAG_END)))
	return(1);  // Kann Screen nicht oeffnen

    ScrWidth  = width;
    ScrHeight = height;
    ScrOScan  = oscan;
    ScrDepth  = depth;
    ScrDId    = mode;

    PubScreenName = PubName;

    PubScreenStatus(MyScreen,0);

    SetupScreen();  // Oeffnet BOOBSI

    MaxScreenX = MyScreen->Width;
    MaxScreenY = MyScreen->Height;

    short xf = MyScreen->RastPort.Font->tf_XSize;

    if (xf<2) xf = 8;

    DockSizeX  = xf * 14;

    ScrLimXend = MaxScreenX;
    ScrLimYend = MaxScreenY;

    ScrLimXstart = 0;

    if (!(DrawWin = OpenWindowTags(NULL,
		WA_Top,    0,
		WA_Width,  ScrLimXend,
		WA_Height, ScrLimYend,
		WA_IDCMP,  IDCMP_MOUSEBUTTONS|IDCMP_MOUSEMOVE|IDCMP_RAWKEY|
			   IDCMP_VANILLAKEY,
		WA_Flags,  WFLG_REPORTMOUSE|WFLG_ACTIVATE|WFLG_RMBTRAP|
			   WFLG_BACKDROP|WFLG_BORDERLESS,
		WA_CustomScreen, MyScreen,
		TAG_END)))
	return(2);  // Kann Draw-Window nicht ffnen

/*
**  StatusWin:	zeigt den aktuellen Status incl. Koordinaten etc. an.
**		  RMB	 : Zeigt Menu
**		  RAWKEY : fhrt SelectKey() aus
**  DrawWin:	Edit Window.
**		  RMB	 : lschen
**		  RAWKEY : fhrt SelectKey() aus
*/
    OpenDock();
    StatusHeight = myfont8.ta_YSize+3;

    ScrLimYstart = StatusHeight;

    if (!(StatusWin = OpenWindowTags(NULL,
		WA_Top,    0,
		WA_Width,  MaxScreenX,
		WA_Height, StatusHeight,
		WA_Gadgets, NULL,
		WA_IDCMP,  IDCMP_INACTIVEWINDOW|IDCMP_MOUSEMOVE|IDCMP_RAWKEY|
			   IDCMP_VANILLAKEY|IDCMP_MENUPICK|IDCMP_GADGETUP,
		WA_Flags,  WFLG_REPORTMOUSE|WFLG_BORDERLESS,
		WA_CustomScreen, MyScreen,
		TAG_END)))
	return(3);  // Kann Status-Window nicht ffnen

    StatusWin->BorderTop = 0;

    MyProcess = (struct Process *) FindTask(NULL);
    OldErrorWindow = MyProcess->pr_WindowPtr;

    MyProcess->pr_WindowPtr = (APTR) StatusWin;
    pr_Flag = TRUE;

    Signals = ((1<<DrawWin->UserPort->mp_SigBit)| \
	      (1<<StatusWin->UserPort->mp_SigBit)| \
	      (1<<DockWin->UserPort->mp_SigBit));

    RP = (struct RastPort *) DrawWin->RPort;
    RPs = (struct RastPort *) StatusWin->RPort;

    ViewPort = &(MyScreen->ViewPort);
    if (!(BitPlane = AllocRaster(ScrLimXend,ScrLimYend)))
	return(4);  // Nicht genug Chip ram frei (BitPlane)

    InitTmpRas(&Raster,(char *) BitPlane,RASSIZE(ScrLimXend,ScrLimYend));
    RP->TmpRas = &Raster;

    SetDrMd(RP,JAM1);
    SetAPen(RP,ClsCol);
    RectFill(RP,0,10,ScrLimXend,ScrLimYend); /* Bildschirm lschen */
    SetAPen(RP,2);
    SetStdColor();
    SetRGB4(ViewPort,19,0,0,7);
    SetRGB4(ViewPort,18,15,15,0);

    if (!(CPMenus = CreateMenus( PlotNewMenu, GTMN_FrontPen, 0L, TAG_DONE)))
	return(5);

    LayoutMenus( CPMenus, VisualInfo, TAG_DONE );
    SetMenuStrip(StatusWin,CPMenus);

    SetPointer(DrawWin,(USHORT *) NewPointer_data,16,16,-8,-7);

    return(0);
}

void CloseAlScreen(void)
{
    struct Process *MyProcess;

#ifdef DEBUG
    if (DebugLevel > 0)
	printf("Enter CloseAlScreen\n");
#endif

    MyProcess = (struct Process *) FindTask(NULL);
    if (pr_Flag) MyProcess->pr_WindowPtr = OldErrorWindow;

    CloseDock();
    CloseDownScreen();	// Schliesst BOOBSI

    if (CPMenus)
    {
			ClearMenuStrip(StatusWin);
			FreeMenus(CPMenus);
			CPMenus = NULL;
    }
    if (BitPlane)	FreeRaster(BitPlane,ScrLimXend,ScrLimYend);

    if (StatusWin)	CloseWindow(StatusWin);
    if (DrawWin)	CloseWindow(DrawWin);
    if (MyScreen)	CloseScreen(MyScreen);

    StatusWin = NULL;
    DrawWin =	NULL;
    MyScreen =	NULL;
    BitPlane =	NULL;

}

void SetStdColor(void)
{
#ifdef DEBUG
    if (DebugLevel > 0)
	printf("Enter SetStdColor\n");
#endif

    SetRGB4(ViewPort,0,10,10,10);
    SetRGB4(ViewPort,1,0,0,0);
    SetRGB4(ViewPort,2,15,15,15);
    SetRGB4(ViewPort,3,15,0,8);
    SetRGB4(ViewPort,4,0,0,13);
    SetRGB4(ViewPort,5,0,15,0);
    SetRGB4(ViewPort,6,15,0,15);
    SetRGB4(ViewPort,7,15,15,0);
}

void SelMButtons(void)
{
#ifdef DEBUG
    if (DebugLevel > 1)
	printf("Enter SelMouseButtons\n");
#endif

    if (Message->Code == IECODE_RBUTTON)
    {
	move_x = x;
	move_y = y;
	MoveFlag = TRUE;
    }
    if (Message->Code == MENUUP)   // MENUUP == IECODE_RBUTTON+IECODE_UP_PREFIX
    {
	if ((move_x == x) AND (move_y == y))
	{
	    DoSelect();
	    MoveFlag = FALSE;
	}
	else if (MoveFlag)
	    MoveIt();
    }
}

void main(int argc, char *argv[])
{
    if (argc == 2)    // Debug Parameter vorhanden...
    {
	DebugLevel = 0;
	sscanf(argv[1], "%d", &DebugLevel);

	if (DebugLevel)
	    printf("Debugging turned on, debug level  %d\n\n", DebugLevel);
	else
	    printf("Wrong debugging value\n\n");
    }
    OpenCfg();
    OpenAll();
    UpdateUndo();
    FontInit();

    Tool = ADD_TRACE;
    ChangeSize(1);
    Tool = ADD_PAD;
    ChangeSize(1);

    Message = &MyMess;
    Message->MouseX = 100;
    Message->MouseY = 100;

    GetKoords();
    x2 = x;
    y2 = y;
    DrawPad(x2,y2,PinSize,INVERS);

    DoInfo();

    PRKoords();
    DoRefresh();

    FOREVER
    {
	Wait(Signals);	 /* Warten auf Window Ereignis */
/*
    Falls StatusWin-Msg, dann auswerten.
    Bisher nur RawKey und MenuPick.
*/
	if (MyScreen->MouseX==0 AND MyScreen->MouseY > 30)
	    MoveLeft();

	if (MyScreen->MouseY==0 AND MyScreen->MouseX > 100)
	    MoveUp();

	if (MyScreen->MouseX == MyScreen->Width-1)
	    MoveRight();

	if (MyScreen->MouseY == MyScreen->Height-1)
	    MoveDown();

	if (Message = (struct IntuiMessage *) GetMsg(StatusWin->UserPort))
	{
	    CopyMem((APTR) Message, (APTR) &MyMess, sizeof(struct IntuiMessage));
	    ReplyMsg((struct Message *) Message);   // und reply-en
	    Message = &MyMess;			    // Intui-Msg retten

	    if (Message->Class != MENUPICK)
		DoWinActivate();

	    switch (Message->Class)
	    {
		case IDCMP_RAWKEY:
		    SelectRawKey();
		    break;
		case IDCMP_VANILLAKEY:
		    SelectVanillaKey();
		    break;
		case IDCMP_MENUPICK:
		    SelectMenu();
		    break;
		case IDCMP_GADGETUP:
		    SelectGadSt();
		    break;
		case IDCMP_INACTIVEWINDOW:
		    PRKoords();
		    break;
	    }
	    EmptyMsgPort();
	}
/*
    Falls DrawWin-Msg, dann auswerten.
    Prft erst, ob RAWKEY oder MOUSEMOVE, aktualisiert dann die
    Koordinaten oder ruft SelectKey() auf.

    Springt dann in die Unterroutinen.
*/
	else if (Message = (struct IntuiMessage *) GetMsg(DockWin->UserPort))
	{
	    CopyMem((APTR) Message, (APTR) &MyMess, sizeof(struct IntuiMessage));
	    ReplyMsg((struct Message *) Message);
	    Message = &MyMess;			    // Intui-Msg retten

	    DoWinActivate();

	    switch (Message->Class)
	    {
		case IDCMP_MOUSEBUTTONS:
		    SelectDock();
		    break;

		case IDCMP_RAWKEY:
		    SelectRawKey();
		    break;

		case IDCMP_VANILLAKEY:
		    if (Tool == ADD_TEXT AND DrawKey)
			SetText();
		    else
			SelectVanillaKey();
		    break;
	    }
	    EmptyMsgPort();
	}
	else if (Message = (struct IntuiMessage *) GetMsg(DrawWin->UserPort))
	{
	    CopyMem((APTR) Message, (APTR) &MyMess, sizeof(struct IntuiMessage));
	    ReplyMsg((struct Message *) Message);
	    Message = &MyMess;			    // Intui-Msg retten

	    DoWinActivate();

	    GetKoords();
	    switch (Message->Class)
	    {
		case IDCMP_RAWKEY:
		    SelectRawKey();
		    break;

		case IDCMP_VANILLAKEY:
		    if (Tool == ADD_TEXT AND DrawKey)
			SetText();
		    else
			SelectVanillaKey();
		    break;

		case IDCMP_MOUSEMOVE:
		    if (x!=x1 OR y!=y1)
		    {
			PrintKoordsXY();
			if (Tool != PART_ADD)
			{
			    SetDrMd(RP,JAM1|COMPLEMENT);
			    WritePixel(RP,Zoll2X(kx),Zoll2Y(ky));
			}
			if (PCBXYFLAG)
			    DrawXY(kx,ky);
			kx = x;
			ky = y;
			if (PCBXYFLAG)
			    DrawXY(kx,ky);
			if (Tool != PART_ADD)
			    WritePixel(RP,Zoll2X(kx),Zoll2Y(ky));
		    }
		    break;
		case IDCMP_MOUSEBUTTONS:
		    SelMButtons();
		    break;
	    }
Loop:
	    if (Message)
	    {
		switch(Tool)
		{
		    case ADD_PAD:     SetPad();
					break;
		    case ADD_TRACE:   SetTrace();
					break;
		    case ADD_LINE:    SetLine();
					break;
		    case ADD_ELLIPSE: SetEllipse();
					break;
		    case ADD_CIRCLE:  SetCircle();
					break;
		    case ADD_RECT:    SetRect();
					break;
		    case ADD_TEXT:    SetText();
					break;
		    case PART_CLEAR:  SelectPart();
					break;
		    case PART_COPY:   SelectPart();
					break;
		    case PART_ADD:    SetPart();
					break;
		}
	    }
	    while (Message = (struct IntuiMessage *) GetMsg(DrawWin->UserPort))
	    {
		CopyMem((APTR) Message, (APTR) &MyMess, sizeof(struct IntuiMessage));
		ReplyMsg((struct Message *) Message);
		Message = &MyMess;

		DoWinActivate();

		if (Message->Class == IDCMP_MOUSEBUTTONS)
		{
		    SelMButtons();
		    goto Loop;			    /* Sorry, GOTO... */
		}
	    }
	}			/* End If */
    }			      /* End Forever */
}			   /* End Main */
