/********************************************************************
 *
 * PROGRAM:  CrazyPads
 * PART:     menu.c
 * CONTENTS:
 *
 * (c) Copyright 1990-94 by Klaus Rotter. All rights reserved.
 * EMail: klaus@rotters.de
 *
 * Use it at your own risk. The program and the source code may be 
 * distributed under the terms of the GNU Public Licence (GPL).
 * For more informations read mainmodule (main.c) and CrazyPads.doc.
 *
 ********************************************************************/

#include "defs.h"
#include "debug.h"
#include "/obj/prog-protos.h"

Prototype void SelectMenu(void);
Prototype void DoInfo(void);
Prototype void OpenCfg(void);

Prototype struct CP_Config Cfg;
Prototype struct PCB *ActualPCB;
Prototype char dummy[80];

struct PCB *ActualPCB;

struct CP_Config Cfg;
struct PCB InitPCB;

void SetUpStdCfg(void)
{
    Cfg.TraceSize[1] = StrToIn("0.3mm");
    Cfg.TraceSize[2] = StrToIn("0.5mm");
    Cfg.TraceSize[3] = StrToIn("0.8mm");
    Cfg.TraceSize[4] = StrToIn("1.0mm");
    Cfg.TraceSize[5] = StrToIn("1.5mm");
    Cfg.TraceSize[6] = StrToIn("2.0mm");
    Cfg.TraceSize[7] = StrToIn("2.5mm");
    Cfg.TraceSize[8] = StrToIn("3.0mm");
    Cfg.TraceSize[9] = StrToIn("4.0mm");
    Cfg.TraceSize[0] = StrToIn("5.0mm");

    Cfg.LabelSize[1] = StrToIn("0.3mm");
    Cfg.LabelSize[2] = StrToIn("0.5mm");
    Cfg.LabelSize[3] = StrToIn("0.8mm");
    Cfg.LabelSize[4] = StrToIn("1.0mm");
    Cfg.LabelSize[5] = StrToIn("1.5mm");
    Cfg.LabelSize[6] = StrToIn("2.0mm");
    Cfg.LabelSize[7] = StrToIn("2.5mm");
    Cfg.LabelSize[8] = StrToIn("3.0mm");
    Cfg.LabelSize[9] = StrToIn("4.0mm");
    Cfg.LabelSize[0] = StrToIn("5.0mm");

    ActualPCB = &InitPCB;

    PCBBASEX = 120;
    PCBBASEY = 120;
    PCBZOOM = 100;
    PCBACTSTEP = 1;
    PCBSTEP = StrToIn("2.54mm");
    PCBACTGRID = 1;
    PCBGRID = StrToIn("2.54mm");
    PCBGRIDFLAG = FALSE;
    PCBXYFLAG = FALSE;
    PCBOFFSETX = 0;
    PCBOFFSETY = 0;
    CompNewDPI();
}

BOOL LoadCfg(char *name)
{
    return(FALSE);
}

BOOL SaveCfg(char *name)
{
    return(FALSE);
}

void OpenCfg(void)
{
    if (!(LoadCfg("ENVARC:CrazyPads/Default.prefs")))
	if (!(LoadCfg("ENVARC:CrazyPads.prefs")))
	    SetUpStdCfg();
}

char dummy[200];

void UpdateTraceLabel(void)
{
    InToStr(Cfg.TraceSize[1], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace1G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[2], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace2G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[3], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace3G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[4], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace4G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[5], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace5G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[6], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace6G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[7], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace7G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[8], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace8G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[9], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace9G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[0], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace0G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[1], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label1G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[2], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label2G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[3], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label3G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[4], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label4G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[5], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label5G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[6], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label6G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[7], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label7G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[8], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label8G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[9], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label9G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.LabelSize[0], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Label0G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);

    InToStr(Cfg.TraceSize[1], dummy);
    GT_SetGadgetAttrs(GetGadAddr(TraceLabelWnd,GD_TL_Trace1G),TraceLabelWnd,NULL,
	GTST_String, dummy, TAG_END);
}

void DoTraceLabel(void)
{
    UWORD GadNum;

    OpenTraceLabelWindow();
    UpdateTraceLabel();

    do
    {
	Wait(1<<TraceLabelWnd->UserPort->mp_SigBit);

	if (Message = (struct IntuiMessage *) GT_GetIMsg(TraceLabelWnd->UserPort))
	{
	    CopyMem((APTR) Message, (APTR) &MyMess, sizeof(struct IntuiMessage));
	    GT_ReplyIMsg((struct IntuiMessage *) Message);
	    Message = &MyMess;

	    GadNum = ((struct Gadget *) Message->IAddress)->GadgetID;

	    switch (GadNum)
	    {
		case GD_TL_Trace1G:
		    Cfg.TraceSize[1] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace2G:
		    Cfg.TraceSize[2] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace3G:
		    Cfg.TraceSize[3] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace4G:
		    Cfg.TraceSize[4] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace5G:
		    Cfg.TraceSize[5] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace6G:
		    Cfg.TraceSize[6] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace7G:
		    Cfg.TraceSize[7] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace8G:
		    Cfg.TraceSize[8] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace9G:
		    Cfg.TraceSize[9] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_TL_Trace0G:
		    Cfg.TraceSize[0] = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;
	    }
	    UpdateTraceLabel();
	}
    }
    while (GadNum != GD_TL_OkG AND GadNum != GD_TL_CancelG);

    CloseTraceLabelWindow();
}

char InfoTxt[] =
	  "Crazy Pads was written 1990-94 by\n\n"
	  "Klaus Rotter\n"
	  "Email: klaus@rotters.de\n\n"
	  "CrazyPads Version %s compiled %s at %s\n\n"
#ifdef ALPHA
	  "THIS IS A ALPHA RELEASE. THERE ARE A LOT OF BUGS.\n"
	  "THIS ONE IS ONLY FOR PEOPLE WHO REALLY KNOW WHAT THEY ARE DOING.\n\n"
#endif
#ifdef BETA
	  "THIS IS A BETA RELEASE. THERE MAY BE A LOT OF BUGS.\n"
	  "SO, IF YOU DON'T KNOW WHAT YOU'RE DOING DON'T USE IT\n\n"
#endif
	  "The complete source may be distributed under the term of the\n"
	  "GNU Public Licence";

void DoInfo(void)
{
    ULONG tags[] = {
	RT_Window, (ULONG) DrawWin,
	RTEZ_ReqTitle, (ULONG) " About CrazyPads... ",
	RT_ReqPos, (ULONG) REQPOS_CENTERSCR,
	RTEZ_Flags, (ULONG) EZREQF_CENTERTEXT,
	TAG_END };

    rtEZRequest(&InfoTxt[0],"   OK   ",NULL,(struct TagItem *) tags,&versiontxt[0],&compdate[0],&comptime[0]);
}

void SelectMenu(void)
{
    struct rtFontRequester	 *fontreq;
    struct rtScreenModeRequester *scrmodereq;
    short			  err;

    if (Message->Code != MENUNULL)
    {
	switch (MENUNUM(Message->Code))
	{
	    case 0:
		switch (ITEMNUM(Message->Code))
		{
		    case 0:			    /* About */
			DoInfo();
			break;

		    //	1 BARLABEL

		    case 2:			    /* New */
			if (rtEZRequest("OK to erase all data ?","  OK  | Cancel ",NULL,(struct TagItem *) mtags) == 1) {
			    UpdateUndo();
			    PCBEnd = PCBStart;
			    PCBEnd->Type = 0;
			    ModCnt = 0;
			    DoRefresh();
			}
			break;

		    case 3:			   /* Board Prefs */
			OpenBoardPrefWindow();
			DoSorry();
			CloseBoardPrefWindow();
			break;

		    //	4 BARLABEL

		    case 5:
			if (FileRequest(" Load "))
			    if (!LoadIt())
				rtEZRequest("I have some troubles loading the file\n'%s'","Oh No",NULL,(struct TagItem *) mtags,&AnswerArray[0]);
			    else
				DoRefresh();
			break;

		    case 6:			    /* Save */
		    case 7:			    /* Save As */
			if (FileRequest(" Save "))
			    if (!SaveIt())
				rtEZRequest("Sorry, can't save the file\n'%s'","  Oh No  ",NULL,(struct TagItem *) mtags,&AnswerArray[0]);
			    else
				DoRefresh();
			break;

		    case 8:			    /* Save & Quit */

		    // 9 BARLABEL

		    case 10:			     /* Print */
			PrintIt();
			break;

		    case 11:			    // HPGL-Plot
			break;

		    // BARLABEL 12

		    case 13:			    /* Quit */

			if (ModCnt == 0)
			    Ende(0);
			else if (ModCnt == 1) {
			    if (rtEZRequest("You have done one modification to '%s'\nQuit anyway ?","  Quit  | Save first | Cancel ",NULL,(struct TagItem *) mtags,&FRName[0]) == 1)
			    Ende(0);
			}
			else {
			    if (rtEZRequest("You have done %ld modifications to '%s'\nQuit anyway ?","  Quit  | Save first | Cancel ",NULL,(struct TagItem *) mtags,ModCnt,&FRName[0]) == 1)
			    Ende(0);
			}
			break;
		}
		break;
	    case 2:
		switch (ITEMNUM(Message->Code))
		{
		    case 0:
		    case 1:
		    case 2:
		    case 3:
		    case 4:

		    // BARLABEL 5

		    case 6:			    /* Rotate	    */
		    case 7:			    /* Edit	    */

		    // BARLABEL 6

		    case 8:			    /* Load	    */
		    case 9:			    /* Save As	    */
		    case 10:			    /* Library	    */
			DoSorry();
			break;
		}
		break;
	    case 3:
		switch (ITEMNUM(Message->Code))
		{
		    case 0:	    // Palette
			rtPaletteRequest (" Change palette", NULL, TAG_END);
			break;
		    case 1:	    // Screen
			if (scrmodereq = rtAllocRequestA (RT_SCREENMODEREQ, NULL)) {
			    if (rtScreenModeRequest(scrmodereq, "Select new screen mode:",
				RT_ReqPos,  REQPOS_CENTERSCR,
				RTSC_Flags, SCREQF_DEPTHGAD|SCREQF_SIZEGADS|
					    SCREQF_GUIMODES|SCREQF_OVERSCANGAD,
				RTSC_MinDepth, 2,
				RTSC_MinHeight, 200,
				TAG_END))
			    {
				CloseAlScreen();
				err = OpenAlScreen(scrmodereq->DisplayWidth,
					scrmodereq->DisplayHeight,
					scrmodereq->OverscanType,
					scrmodereq->DisplayDepth,
					scrmodereq->DisplayID);

				if (err) OpenScrErr(err);
				else
				{
				    PCBZOOM = 100;
				    PCBBASEX = 256;
				    ActualdpiX = 256;

				    if ((2*(scrmodereq->DisplayHeight)) < (scrmodereq->DisplayWidth))
				    {
					PCBBASEY = 128;
					ActualdpiY = 128;
				    }
				    else
				    {
					PCBBASEY = 256;
					ActualdpiY = 256;
				    }
				    DoRefresh();
				}
			    }
			    rtFreeRequest (scrmodereq);
			}
			break;
		    case 2:	// Colors
			switch (SUBNUM(Message->Code))
			{
			    case 0: // Grey-4 A2024
				SelectCol = 2;
				ClsCol = 1;
				CompoLayerCol = 3;
				CompoInactiveCol = 3;
				SolderLayerCol = 0;
				SolderInactiveCol = 0;
				LabelLayerCol = 2;
				LabelInactiveCol = 2;
				GridCol = 2;
				PadCol = 2;

				SelectMask = 2;
				SolderMask = 1;
				CompoMask = 2;
				LabelMask = 0xff;
				DoRefresh();
				UpdateColors();
				break;

			    case 1: // Grey-8
				SelectCol = 6;
				ClsCol = 1;
				CompoLayerCol = 3;
				CompoInactiveCol = 0;
				SolderLayerCol = 5;
				SolderInactiveCol = 0;
				LabelLayerCol = 2;
				LabelInactiveCol = 2;
				GridCol = 4;
				PadCol = 7;

				SelectMask = 6;
				SolderMask = 4;
				CompoMask = 2;
				LabelMask = 0xff;
				DoRefresh();
				UpdateColors();
				break;

			    case 2: // Color-8
				SelectCol = 6;
				ClsCol = 1;
				CompoLayerCol = 3;
				CompoInactiveCol = 0;
				SolderLayerCol = 5;
				SolderInactiveCol = 0;
				LabelLayerCol = 2;
				LabelInactiveCol = 2;
				GridCol = 4;
				PadCol = 7;

				SelectMask = 6;
				SolderMask = 4;
				CompoMask = 2;
				LabelMask = 0xff;
				DoRefresh();
				UpdateColors();
				break;


			    case 3: // Color-16
			    case 4: // Color-256
			    case 5: // Custom
				DoSorry();
				break;

			}
			break;
		    case 3:	// Font
			if (fontreq = rtAllocRequestA (RT_FONTREQ, NULL))
			{
			    if (rtFontRequest(fontreq, "Pick new font", RT_ReqPos, REQPOS_CENTERSCR, RTFO_Flags, FREQF_FIXEDWIDTH, TAG_END)) {
				strcpy(myfont8.ta_Name,fontreq->Attr.ta_Name);
				myfont8.ta_YSize = fontreq->Attr.ta_YSize;
				CloseAlScreen();
				err = OpenAlScreen(ScrWidth, ScrHeight, ScrOScan, ScrDepth, ScrDId);
			    }
			    rtFreeRequest (fontreq);
			    DoRefresh();
			}
			break;
		    case 4:	// Traces & Labels
			DoTraceLabel();
			break;

		    case 5:	// Pads
			OpenEditPadsWindow();
			DoSorry();
			CloseEditPadsWindow();
			break;

		    case 6:	// Misc
			OpenMiscWindow();
			DoSorry();
			CloseMiscWindow();
			break;

		    case 7:
		    case 8:
		    case 9:
			DoSorry();
			break;
		}
		break;
	}
	EmptyMsgPort();
	PRKoords();
    }
}
