/********************************************************************
 *
 * PROGRAM:  CrazyPads
 * PART:     print.c
 * CONTENTS:
 *
 * (c) Copyright 1990-94 by Klaus Rotter. All rights reserved.
 * EMail: klaus@rotters.de
 *
 * Use it at your own risk. The program and the source code may be 
 * distributed under the terms of the GNU Public Licence (GPL).
 * For more informations read mainmodule (main.c) and CrazyPads.doc.
 *
 ********************************************************************/

#include "defs.h"
#include "/obj/prog-protos.h"

Prototype void PrintIt(void);

Prototype short PrtDraw;
Prototype short DotSize;

Local int InitRP(short PrFlag);
Local void DoPrintPCB(void);
Local void MoveRP(void);

UWORD colors[] = { 0xFFF, 0 };

struct Screen *PrScr;
struct Window *PrWin;
struct RastPort *PrRp;

struct IODRPReq PReq;
struct PrinterData *PD;
struct PrinterExtendedData *PED;

struct MsgPort MyPort;

short DotSize = 010; // Fuer Nadeldrucker 1/100 in

short PrtDraw;
short x_dpi, y_dpi;

short LabelFlag    = FALSE;
short SolderFlag   = TRUE;
short CompoFlag    = FALSE;
short PadFlag	   = TRUE;
short DrillFlag    = FALSE;
short MirrorFlag   = FALSE;
short ShowHoleFlag = TRUE;
short FormFeedFlag = FALSE;
short InverseFlag  = FALSE;   // IMAGE_POSITIVE
short AspectFlag   = TRUE;    // HORIZONTAL
short PrintZoom    = 2;       // 100%
short PrintDot	   = 010;     // Einheit 1/1600 in
short PrintLines   = 1024;
short PrintDensity = 7;

void DoNoPrint(void)
{
    struct Message *msg;

    MyPort.mp_SigTask = FindTask(0);
    AddPort(&MyPort);
    PReq.io_Message.mn_ReplyPort = &MyPort;

    PReq.io_Command = PRD_DUMPRPORT;
    PReq.io_RastPort = RP;
    PReq.io_ColorMap = MyScreen->ViewPort.ColorMap;
    PReq.io_Modes = GetVPModeID(&(MyScreen->ViewPort));
    PReq.io_SrcX = 0;
    PReq.io_SrcY = 0;
    PReq.io_SrcWidth  = MyScreen->Width;
    PReq.io_SrcHeight = MyScreen->Height;
    PReq.io_DestCols  = MyScreen->Width;
    PReq.io_DestRows  = MyScreen->Height;
    PReq.io_Special = SPECIAL_DENSITY7|SPECIAL_NOPRINT;
    DoIO((struct IORequest *) &PReq);
    while ((msg = GetMsg(&MyPort)) != NULL)
	ReplyMsg(msg);

    RemPort(&MyPort);
}

Local struct RastPort *p_Rp;

void UpdatePrintWin(void)
{
    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_LabelG),PrintXWnd,NULL,
	GTCB_Checked, LabelFlag, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_SolderG),PrintXWnd,NULL,
	GTCB_Checked, SolderFlag, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_CompoG),PrintXWnd,NULL,
	GTCB_Checked, CompoFlag, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_PadG),PrintXWnd,NULL,
	GTCB_Checked, PadFlag, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_DrillG),PrintXWnd,NULL,
	GTCB_Checked, DrillFlag, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_MirrorG),PrintXWnd,NULL,
	GTCB_Checked, MirrorFlag, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_ShowHoleG),PrintXWnd,NULL,
	GTCB_Checked, ShowHoleFlag, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_FormFeedG),PrintXWnd,NULL,
	GTCB_Checked, FormFeedFlag, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_InverseG),PrintXWnd,NULL,
	GTCB_Checked, InverseFlag, TAG_END);

    if (InverseFlag)
	PD->pd_Preferences.PrintImage = IMAGE_NEGATIVE;
    else
	PD->pd_Preferences.PrintImage = IMAGE_POSITIVE;

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_ZoomG),PrintXWnd,NULL,
	GTCY_Active, PrintZoom, TAG_END);

    char buf[40];

    InToStr(DotSize,&buf[0]);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_DotG),PrintXWnd,NULL,
	GTST_String, &buf[0], TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_LineG),PrintXWnd,NULL,
	GTIN_Number, PrintLines, TAG_END);

    GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_DensityG),PrintXWnd,NULL,
	GTNM_Number, PrintDensity, TAG_END);

    PD->pd_Preferences.PrintDensity = PrintDensity;
    DoNoPrint();

    x_dpi = PED->ped_XDotsInch;
    y_dpi = PED->ped_YDotsInch;

    sprintf(&dummy[0],"%d x %d dpi  ", x_dpi,y_dpi);
    PrintText(p_Rp,OffX+ComputeX(100),OffY+ComputeY(17+2),&dummy[0],3,JAM2);

    sprintf(&dummy[0],"%d x %d dots  ", PED->ped_MaxXDots, PED->ped_MaxYDots);
    PrintText(p_Rp,OffX+ComputeX(100),OffY+ComputeY(25+2),&dummy[0],3,JAM2);

    if (AspectFlag)
	GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_AspectG),PrintXWnd,NULL,
	    GTCY_Active, 0, TAG_END);
    else
	GT_SetGadgetAttrs(GetGadAddr(PrintXWnd,GD_Pr_AspectG),PrintXWnd,NULL,
	    GTCY_Active, 1, TAG_END);

    if (AspectFlag)
	PD->pd_Preferences.PrintAspect = ASPECT_HORIZ;
    else
	PD->pd_Preferences.PrintAspect = ASPECT_VERT;

    sprintf(&dummy[0],"%s", PED->ped_PrinterName);
    PrintText(p_Rp,OffX+ComputeX(100),OffY+ComputeY(9+2),&dummy[0],3,JAM1);
}

int OpenPrintWin(void)
{
    if (OpenPrintXWindow())	 // Falls Fehler, zurueck
    {
	rtEZRequest("Can't open PrintWindow\n Maybe you ran out of Chip-Mem"," Forget it ",NULL,(struct TagItem *) mtags);
	return(0);
    }
    p_Rp = PrintXWnd->RPort;

    UpdatePrintWin();

    return(1);
}

int ClosePrintWin(void)
{
    ClosePrintXWindow();
    p_Rp = NULL;
}

void PrintIt(void)
{
    short  EndFlag, GadNum;

    CleanUp();
    if (OpenDevice("printer.device", 0, (struct IORequest *) &PReq, 0) != NULL)
    {
	rtEZRequest("Can't open printer.device"," Forget it ",NULL,(struct TagItem *) mtags);
	return;
    }
    PD = (struct PrinterData *)PReq.io_Device;
    PED = &PD->pd_SegmentData->ps_PED;

    PD->pd_Preferences.PrintShade   = SHADE_BW;
    PD->pd_Preferences.PrintThreshold = 10;

    if (!(OpenPrintWin()))
	return;

    EndFlag = FALSE;

    do {
	if (Message = (struct IntuiMessage *) GT_GetIMsg(PrintXWnd->UserPort)) {
	    CopyMem((APTR) Message, (APTR) &MyMess, sizeof(struct IntuiMessage));
	    GT_ReplyIMsg((struct IntuiMessage *) Message);
	    Message = &MyMess;

	    GadNum = ((struct Gadget *) Message->IAddress)->GadgetID;

	    switch (GadNum)
	    {
		case GD_Pr_LabelG:
		    LabelFlag = !LabelFlag;
		    break;

		case GD_Pr_SolderG:
		    SolderFlag = !SolderFlag;
		    break;

		case GD_Pr_CompoG:
		    CompoFlag = !CompoFlag;
		    break;

		case GD_Pr_PadG:
		    PadFlag = !PadFlag;
		    break;

		case GD_Pr_DrillG:
		    DrillFlag = !DrillFlag;
		    break;

		case GD_Pr_MirrorG:
		    MirrorFlag = !MirrorFlag;
		    break;

		case GD_Pr_ShowHoleG:
		    ShowHoleFlag = !ShowHoleFlag;
		    break;

		case GD_Pr_FormFeedG:
		    FormFeedFlag = !FormFeedFlag;
		    break;

		case GD_Pr_InverseG:
		    InverseFlag = !InverseFlag;
		    break;

		case GD_Pr_PrintG:
		    ClosePrintWin();
		    InitRP(TRUE);
		    OpenPrintWin();
		    break;

		case GD_Pr_CancelG:
		    EndFlag = TRUE;
		    break;

		case GD_Pr_ShowG:
		    InitRP(FALSE);
		    break;

		case GD_Pr_ZoomG:
		    PrintZoom = Message->Code;
		    break;

		case GD_Pr_DotG:
		    DotSize = StrToIn(((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->Buffer);
		    break;

		case GD_Pr_LineG:
		    PrintLines = ((struct StringInfo *)((struct Gadget *) Message->IAddress)->SpecialInfo)->LongInt;
		    break;

		case GD_Pr_DensityG:
		    PrintDensity = Message->Code;
		    break;

		case GD_Pr_AspectG:
		    AspectFlag = !AspectFlag;
		    break;
	    }
	    UpdatePrintWin();
	}
	else
	    Wait(1<<PrintXWnd->UserPort->mp_SigBit);
    }
    while (EndFlag == FALSE);

    CloseWindow(PrintXWnd);
    CloseDevice((void *) &PReq);
}

void DoPrintPCB(void)
{
    struct Message *msg;
    ULONG  signal, sigbit;

    MyPort.mp_SigTask = FindTask(0);
    if ((sigbit = AllocSignal(-1)) != -1)
	MyPort.mp_SigBit = sigbit;
    else
    {
	puts("Can't alloc signal (DoPrintPCB) Error");
	return;
    }
    AddPort(&MyPort);

    PReq.io_Message.mn_ReplyPort = &MyPort;
    PReq.io_Command = PRD_DUMPRPORT;
    PReq.io_RastPort = PrRp;
    PReq.io_ColorMap = PrScr->ViewPort.ColorMap;
    PReq.io_Modes = GetVPModeID(&(PrScr->ViewPort));
    PReq.io_SrcX = 0;
    PReq.io_SrcY = 0;
    PReq.io_SrcWidth = PrScr->Width;
    PReq.io_SrcHeight = PrScr->Height;
    PReq.io_DestCols = PrScr->Width;
    PReq.io_DestRows = PrScr->Height;
    if (FormFeedFlag)
	PReq.io_Special = SPECIAL_DENSITY7;
    else
	PReq.io_Special = SPECIAL_DENSITY7|SPECIAL_NOFORMFEED;

    // DoIO((struct IORequest *) &PReq);

    if (OpenPrintingWindow())	   // Falls Fehler, zurueck
	return;
/*
**     The recommended way to do asynchronous i/o is...
**
**  a) To send requests for i/o.
*/
    signal = (1<<MyPort.mp_SigBit)|(1<<PrintingWnd->UserPort->mp_SigBit);

    SendIO((struct IORequest *) &PReq);     // send request, start Printing
    Wait(signal);  // wait for completion (go to sleep)

    if (Message = (struct IntuiMessage *) GT_GetIMsg(PrintingWnd->UserPort))
    {
	if (((struct Gadget *) Message->IAddress)->GadgetID == GD_PI_CancelG)
	{
	    AbortIO((struct IORequest *) &PReq);    // abort request
	    WaitIO((struct IORequest *) &PReq);     // wait for reply
	}
	GT_ReplyIMsg((struct IntuiMessage *) Message);

	while ((msg = GetMsg(PrintingWnd->UserPort)) != NULL)
	    ReplyMsg(msg);
	ClosePrintingWindow();
    }
    else if (msg = GetMsg(&MyPort))
    {
	while ((msg = GetMsg(PrintingWnd->UserPort)) != NULL)
	    ReplyMsg(msg);
	ClosePrintingWindow();
    }
    while ((msg = GetMsg(&MyPort)) != NULL)
	ReplyMsg(msg);
    FreeSignal(sigbit);
    RemPort(&MyPort);
}

/*
     while ((Msg = GetMsg(port)) != NULL) {  get ALL messages
     }

 b) To abort a previous request for i/o.

     struct IORequest *ioreq;

     AbortIO(ioreq);  abort request
     WaitIO(ioreq);  wait for reply

     at this point you can re-use 'ioreq'.

     Note that in the above examples 'ioreq' could be any one of...
     a) struct IOStdReq    a standard i/o request
     b) struct IODRPReq    a dumprport i/o request
     c) struct IOPrtCmdReq a printer command i/o request

     It is recommend that you do asynchronous i/o in your programs
     and give the user a way of aborting all requests.
*/

int InitRP(short PrFlag)
{
    short SaveActDPIX,SaveActDPIY;
    struct RastPort *SaveRP;

    short OldScrX, OldScrY;
    short OldSolder, OldComponent, OldLabel, OldPad;

    struct TmpRas PrRas;
    PLANEPTR	  *PrPlane;

    if (!(PrScr = OpenScreenTags(NULL, SA_AutoScroll, TRUE,
		    SA_DisplayID, NTSC_MONITOR_ID,
		    SA_Width, 2048, SA_Height, 1024, SA_Depth, 1,
		    SA_Behind, TRUE, TAG_END))) {
	rtEZRequest("Can't print it\n(PrtScr Error)"," Forget it ",NULL,(struct TagItem *) mtags);
	return(0);
    }
    if (!(PrWin = OpenWindowTags(NULL, WA_CustomScreen, PrScr, WA_Borderless, TRUE, TAG_END ))) {
	CloseScreen(PrScr);
	rtEZRequest("Can't print it\n(PrtWin Error)"," Forget it ",NULL,(struct TagItem *) mtags);
	return(0);
    }
    PrRp = PrWin->RPort;
    LoadRGB4(&(PrScr->ViewPort), &colors[0], 2);   // Farben setzen

    if (!(PrPlane = AllocRaster(PrScr->Width,PrScr->Height))) {
	CloseWindow(PrWin);
	CloseScreen(PrScr);
	rtEZRequest("Can't print it\nMaybe you ran out of Chip-Mem\n(Prt-AllocRaster Error)"," Forget it ",NULL,(struct TagItem *) mtags);
	return(0);
    }
    InitTmpRas(&PrRas,(char *) PrPlane,RASSIZE(PrScr->Width,PrScr->Height));

    PrRp->TmpRas = &PrRas;

    SetDrMd(PrRp,JAM1);
    Move(PrRp,0,0);
    ClearScreen(PrRp);

    if (!PrFlag) {
	ScreenToFront(PrScr);
	ActivateWindow(PrWin);
    }

    SaveActDPIX = ActualdpiX;
    SaveActDPIY = ActualdpiY;
    SaveRP	= RP;

    OldScrX = ScrLimXend;
    OldScrY = ScrLimYend;

    ScrLimXend = PrScr->Width;
    ScrLimYend = PrScr->Height;

    switch (PrintZoom)
    {
	case 0: 		// 50%
	    ActualdpiX = x_dpi/2;
	    ActualdpiY = y_dpi/2;
	    break;

	case 1: 		// 75%
	    ActualdpiX = x_dpi*4/3;
	    ActualdpiY = y_dpi*4/3;
	    break;

	case 2: 		// 100%
	    ActualdpiX = x_dpi;
	    ActualdpiY = y_dpi;
	    break;

	case 3: 		// 200%
	    ActualdpiX = x_dpi*2;
	    ActualdpiY = y_dpi*2;
	    break;
	case 4: 		// 300%
	    ActualdpiX = x_dpi*3;
	    ActualdpiY = y_dpi*3;
	    break;
	case 5: 		// 400%
	    ActualdpiX = x_dpi*4;
	    ActualdpiY = y_dpi*4;
	    break;
	case 6: 		// 500%
	    ActualdpiX = x_dpi*5;
	    ActualdpiY = y_dpi*5;
	    break;
    }

    OpenBuildPageWindow();

    RP = PrRp;
    PrtDraw = TRUE;

    OldSolder	    = SolderLayer;
    OldComponent    = ComponentLayer;
    OldLabel	    = LabelLayer;
    OldPad	    = PadLayer;

    if (LabelFlag)
	LabelLayer = LAYER_ACTIVE;
    else
	LabelLayer = LAYER_HIDDEN;

    if (SolderFlag)
	SolderLayer    = LAYER_ACTIVE;
    else
	SolderLayer    = LAYER_HIDDEN;

    if (CompoFlag)
	ComponentLayer = LAYER_ACTIVE;
    else
	ComponentLayer = LAYER_HIDDEN;

    if (PadFlag)
	PadLayer = LAYER_ACTIVE;
    else
	PadLayer = LAYER_HIDDEN;

    RefreshScreen();

    LabelLayer	   = OldLabel;
    ComponentLayer = OldComponent;
    SolderLayer    = OldSolder;
    PadLayer	   = OldPad;

    CloseBuildPageWindow();

    if (PrFlag == TRUE)
	 DoPrintPCB();
    else {
	char *ptr = (char *) 0xbfe001;
	while ((*ptr & 64) == 64);
    }

    ScrLimXend = OldScrX;
    ScrLimYend = OldScrY;

    ActualdpiX = SaveActDPIX;
    ActualdpiY = SaveActDPIY;
    RP = SaveRP;
    PrtDraw = FALSE;

    FreeRaster((char *) PrPlane,PrScr->Width,PrScr->Height);

    CloseWindow(PrWin);
    CloseScreen(PrScr);
}

void FLine(struct RastPort *Rp, short x, short y, short dx, short dy)
{
    int fehler, len, ddx, ddy;
    int px = 1, py = 1;

    if (dx == x) {	 // vertikale Linie
	if (dy < y) {
	    ddy = y;
	    y = dy;
	    dy = ddy;
	}
	while (y <= dy)
	    WritePixel(RP,x,y++);
	return;
    }

    if (dy == y) {	 // horizontale Linie
	if (dx < x) {
	    ddx = x;
	    x = dx;
	    dx = ddx;
	}
	while (x <= dx)
	    WritePixel(RP,x++,y);
	return;
    }

    if ((dx -= x) < 0) {
	dx = -dx;
	px = -1;
    }
    if ((dy -= y) < 0) {
	dy = -dy;
	py = -1;
    }

    ddx = dx<<1;
    ddy = dy<<1;

    if (dx > dy) {
	fehler = ddy-dx;
	for (len=0; len <= dx; len++) {
	    WritePixel(Rp,x,y);
	    if (fehler > 0) {
		y += py;
		fehler -= ddx;
	    }
	    fehler += ddy;
	    x += px;
	}
    }
    else {
	fehler = ddx - dy;
	for (len=0; len<=dy; len++) {
	    WritePixel(Rp,x,y);
	    if (fehler > 0) {
		x += px;
		fehler -= ddy;
	    }
	    fehler += ddx;
	    y += py;
	}
    }
}
